define(function(require) {
	var justep = require("$UI/system/lib/justep");
	var ShellImpl = require('$UI/system/lib/portal/shellImpl');
	var dlm = require("$UI/dlapp/js/dlm");
	var browser = require("$UI/system/lib/base/browser");
//	require("cordova!com.justep.cordova.plugin.qq");
//	require("cordova!com.justep.cordova.plugin.weixin.v3");
	var utils = require("$UI/system/components/justep/common/utils");
	
	//引入插件
	require("cordova!cn.zxj.cordova.UmengAnalyticsPlugin");
	require("cordova!com.verso.cordova.clipboard");
	require("cordova!de.appplant.cordova.plugin.background-mode");
	require("cordova!de.appplant.cordova.plugin.badge");
	require("cordova!de.appplant.cordova.plugin.local-notification");
	//require("cordova!cordova-plugin-customurlscheme");
	require("cordova!cordova-plugin-OpenApp");
	
	//插入标题和图标
	$("head").prepend('<title>代练猫</title>'+
   	'<link rel="apple-touch-icon" sizes="144x144" href="http://cloundss.dailianmao.com/images/20170816/144.png"/>'+
   	'<link rel="apple-touch-icon" sizes="114x114" href="http://cloundss.dailianmao.com/images/20170816/114.png"/>'+
   	'<link rel="apple-touch-icon" sizes="72x72" href="http://cloundss.dailianmao.com/images/20170816/72.png"/>');
	
	//判断端类型
	if(window.plugins && navigator.userAgent && navigator.userAgent.indexOf("iPhone")>-1){
		require("css!http://cloundss.oss-cn-hangzhou.aliyuncs.com/dlm/css/ios").load();
	}
	
	var Model = function() {
		this.callParent();
		var shellImpl = new ShellImpl(this, {
			"contentsXid" : "pages",
			"pageMappings" : {
				"main" : {
					url : "$UI/dlapp/main.w"
				},
				"receiveOrder" : {
					url : "$UI/dlapp/page/receiveOrder/receiveOrder.w"
				},
				"login" : {
					url : "$UI/dlapp/page/login/login.w"
				},
				"orderInfo":{
					url : "$UI/dlapp/page/orderManage/orderInfo.w"
				},
				"orderInfo_sqcx":{
					url : "$UI/dlapp/page/orderManage/orderInfo_sqcx.w"
				},
				"orderInfo_sqzc":{
					url : "$UI/dlapp/page/orderManage/orderInfo_sqzc.w"
				},
				"searchOrder":{
					url : "$UI/dlapp/page/receiveOrder/searchOrder.w"
				},
				"orderInfo_tjyc":{
					url : "$UI/dlapp/page/orderManage/orderInfo_tjyc.w"
				},
				"orderChat":{
					url : "$UI/dlapp/page/orderManage/orderChat.w"
				},
				"register" : {
					url : require.toUrl('./page/register/register.w')
				},
				"register_second" : {
					url : require.toUrl('./page/register/register_second.w')
				},
				"tgpInfo_lol" : {
					url : require.toUrl('./page/receiveOrder/tgpInfo_lol.w')
				},
				"tgpInfo_wzry" : {
					url : require.toUrl('./page/receiveOrder/tgpInfo_wzry.w')
				},
				"publish_first" : {
					url : require.toUrl('./page/publish/publish_first.w')
				},
				"publish_index" : {
					url : require.toUrl('./page/publish/publish_index.w')//新的发布页面
				},
				"publish_sec" : {
					url : require.toUrl('./page/publish/publish_sec.w')
				},
				"publish_sec_new" : {
					url : require.toUrl('./page/publish/publish_sec_new.w')
				},
				"publish_final" : {
					url : require.toUrl('./page/publish/publish_final.w')
				},
				"hero_list" : {
					url : require.toUrl('./page/publish/hero_list.w')
				},
				"priceQuery" : {
					url : require.toUrl('./page/publish/priceQueryNew.w')
				},
				"heroPriceQuery" : {
					url : require.toUrl('./page/publish/heroPriceQueryNew.w')
				},
				"receiveOrderProtocol" : {
					url : require.toUrl('./page/receiveOrder/receiveOrderProtocol.w')
				},
				"publishOrderProtocol" : {
					url : require.toUrl('./page/publish/publishOrderProtocol.w')
				},
				"registrationProtocol" : {
					url : require.toUrl('./page/register/registrationProtocol.w')
				},
				"advert" : {
					url : require.toUrl('./page/firstPage/advert.w')
				},
				"onlinePay" : {
					url : require.toUrl('./page/publish/onlinePay.w')
				},
				"openUrl" : {
					url : require.toUrl('./page/message/openUrl.w')
				},
				"noticeInfo" : {
					url : require.toUrl('./page/message/noticeInfo.w')
				},
				"noticeList" : {
					url : require.toUrl('./page/message/noticeList2.w')
				},
				"noticeactivityList" : {
					url : require.toUrl('./page/message/activityList.w')
				},
				"messageList" : {
					url : require.toUrl('./page/message/messageList.w')
				},
				"myCoupon": {
					url : require.toUrl('./page/coupon/myCoupon.w')
				},
				"exchangeCoupon": {
					url : require.toUrl('./page/coupon/exchangeCoupon.w')
				},
				"remindCoupon": {
					url : require.toUrl('./page/message/remindCoupon.w')
				},
				"selectCouponList" : {
					url : require.toUrl('./page/publish/selectCouponList.w')
				},
				"couponHelp" : {
					url : require.toUrl('./page/coupon/couponHelp.w')
				},
				"serviceType": {
					url : require.toUrl('./page/guide/serviceType.w')
				},
				"receiveGuide": {
					url: require.toUrl('./page/guide/receiveGuide.w')
				},
				"releaseGuide": {
					url: require.toUrl("./page/guide/releaseGuide.w")
				},
				"setPasswordHelp": {
					url: require.toUrl("./page/publish/setPasswordHelp.w")
				},
				"addQualityBuyerStep1": {
					url: require.toUrl("./page/qualitybuyer/addQualityBuyerStep1.w")
				},
				"addQualityBuyerStep2": {
					url: require.toUrl("./page/qualitybuyer/addQualityBuyerStep2.w")
				},
				"addQualityBuyer": {
					url: require.toUrl("./page/qualitybuyer/addQualityBuyer.w")
				},
				"profitList": {
					url: require.toUrl("./page/qualitybuyer/profitList.w")
				},
				"pushOrderList": {
					url: require.toUrl("./page/qualitybuyer/pushOrderList.w")
				},
				"pushOrderSetting": {
					url: require.toUrl("./page/qualitybuyer/pushOrderSetting.w")
				},
				"operationRecordList": {
					url: require.toUrl("./page/qualitybuyer/operationRecordList.w")
				},
				"integral": {
					url: require.toUrl("./page/qualitybuyer/integral.w")
				},
				"integralExchange": {
					url: require.toUrl("./page/qualitybuyer/integralExchange.w")
				},
				"yeeOnlinePay": {
					url: require.toUrl("./page/pay/yeeOnlinePay.w")
				},
				"payResult": {
					url: require.toUrl("./page/pay/payResult.w")
				}, 
				"availableCoupon": {
					url: require.toUrl("./page/coupon/availableCoupon.w")
				}
			}
		});
	};
	
	Model.prototype.modelLoad = function(event){
		//判断是否已登录
		var me = this;
//		var url = require.toUrl("./main.w");
//		justep.Shell.loadPage({"url":url});
//		me.comp("mainContainer").setSrc(url);
		//清空错误提示
		window.onerror=function(){
			
		};
		$(document).ajaxError( function(event, jqXHR, options, data){
			
		});
		
		//存储来自第三方网站参数
		me.saveLocalRegisteParams();
		//初始化消息标记
		if(localStorage.notRead && localStorage.userinfo && localStorage.notRead==localStorage.userinfo.userid){
			//设置消息未读标记
			$("#msgtip").show();
		} else{
			$("#msgtip").hide();
		}
		
		//定时刷新未读消息
		var refreshMessage = setInterval(function(){
			me.refresh(refreshMessage);
		}, 15000);
		setTimeout(function(){
			me.refresh();
		}, 1000);
		
		if(browser.isX5App){
			//检测是否有复制分享
			this.getCopyShare();
			me.isactive = 0;
			//APP进入后台模式时触发
			cordova.plugins.backgroundMode.onactivate = function() {
				//进入后台模式，关闭消息获取
				clearInterval(refreshMessage);
				setTimeout(function(){
					//两秒后还是后台模式，才认为真正进入后台模式
					if(cordova.plugins.backgroundMode.isActive()){
						me.isactive = 1;
					}
				},2000);
			};
			//APP从后台模式解除时触发
			cordova.plugins.backgroundMode.ondeactivate = function() {
			
				//重新开启定时刷新消息
				clearInterval(refreshMessage);
				refreshMessage = setInterval(function(){
					me.refresh(refreshMessage);
				}, 15000);
				setTimeout(function(){
					me.refresh(refreshMessage);
				}, 1000);
				
				//是否真正进入后台模式过
				if(me.isactive && me.isactive == 1){
					//检查是否有复制分享
					me.getCopyShare();
				}
				me.isactive = 0;
			};
			//后台模式激活
			cordova.plugins.backgroundMode.enable();
		}else{
			//非APP
			
			//获取URL分享信息
			this.getUrlShare();
			//指定打开链接的页面
			this.getUrlOpen();
			//启动复制插件
			new Clipboard('.copydlapp');
		}
	};

	Model.prototype.refresh = function(refreshMessage){
		var me = this;
		var main = me.comp("mainContainer").getInnerModel();
		if (main == null) {
			setTimeout(function(){
				me.refresh();
			}, 1000);
			return;
		}
		var firstPage = main.comp("firstPageContainer") === null ? null : main.comp("firstPageContainer").getInnerModel();
		var msg = main.comp("messageManageContainer") == null ? null : main.comp("messageManageContainer" ).getInnerModel();
		var receive = main.comp("receiveContainer") == null ? null : main.comp("receiveContainer").getInnerModel();
		
		dlm.sendRequest({
			"action":"/getMsgCount.action",
			"params":{
				
			},
			"async":true,
			"success":function(json){
				if(json.result=="1"){
					if (json.data && json.data.removeUserInfo) {
						localStorage.removeItem("userinfo");
						localStorage.removeItem("orderNewtime");
						localStorage.removeItem("notRead");
					}
					var isQualityBuyerBefore = localStorage.getItem("isQualityBuyer");
					localStorage.setItem("isQualityBuyer", json.data.isQualityBuyer || false);
					if (isQualityBuyerBefore != 'true' && json.data.isQualityBuyer == true && msg != null) {
						msg.pushOrders();
					}
					if(json.data.orderMsg){
						var orderMsg = json.data.orderMsg;
						if(orderMsg && orderMsg.CT && parseInt(orderMsg.CT) && parseInt(orderMsg.CT)>0){
							//$("#orderMsgNum").html(parseInt(orderMsg.CT)>99 ? "99+":parseInt(orderMsg.CT));
							//$("#orderMsgNum").show();
							//判断上次最新未读消息时间
							if(localStorage.orderNewtime){
								if(localStorage.orderNewtime<orderMsg.CREATETIME){
									//标记消息未读标记并更新时间
									$(".msgtip").show();
									localStorage.orderNewtime = orderMsg.CREATETIME;
									localStorage.notRead = localStorage.userinfo.userid;
								}
							} else{
								if(orderMsg.CREATETIME){
									//标记消息未读标记并更新时间
									$(".msgtip").show();
									localStorage.orderNewtime = orderMsg.CREATETIME;
									localStorage.notRead = localStorage.userinfo.userid;
								}
							}
						} else{
							//$("#orderMsgNum").hide();
						}
					} else{
						localStorage.removeItem("orderNewtime");
						localStorage.removeItem("notRead");
					}
					
					if (firstPage) {
						if (json.data.firstPageMessage) {
							var currentFirstPage = json.data.firstPageMessage;
							var cache_firstPageMessage = localStorage.firstPage;
							try {
								var currentFirstPageContent = JSON.stringify(currentFirstPage);
								if (cache_firstPageMessage != currentFirstPageContent) {
									localStorage.firstPage = currentFirstPageContent;
									firstPage.loadAdvert(currentFirstPage);
									
								}
							}
							catch(e)
							{
								
							}
							
						}
						else {
							localStorage.firstPage = null;
							firstPage.loadAdvert([]);
						}
						try{
							firstPage.loadCouponIcon(json.data.iconBean);
						}
						catch (e)
						{
						}
					}
					
					if (receive) {
						if (json.data.hallMessage) {
							try{
								var currentHall = json.data.hallMessage;
								var cache_hallid = localStorage.hallid;
								if (cache_hallid != currentHall.id) {
									localStorage.hallid = currentHall.id;
									$(".jddt-total h2 b").text(currentHall.title);
									$(receive.getElementByXid("hall_noticeid")).val(currentHall.id);
									$(receive.getElementByXid("hall_linkurl")).val(currentHall.linkurl);
									$(receive.getElementByXid("hall_content")).val(currentHall.content);	
									var tempLength=$(".jddt-total h2 b").width();
									var tempLength1=$(".jddt-total h2").width();
									if(tempLength >= tempLength1){
										$(".jddt-total h2 b").text("");
										$(".jddt-total h2 b").append("<marquee direction='left' behavior='scroll' align='right' contenteditable='true' onstart='this.firstChild.innerHTML+=this.firstChild.innerHTML;' scrollamount='3' scrolldelay='-100' loop='-1' width='auto' height='100%' hspace='10' vspace='10'>"+ currentHall.title +"</marquee>");
									}
								}
							}
							catch(e){
								
							}
							
						}
						else {
							localStorage.hallid = null;
							$(".jddt-total h2 b").text("");
							$(receive.getElementByXid("hall_noticeid")).val('');
							$(receive.getElementByXid("hall_linkurl")).val('');
							$(receive.getElementByXid("hall_content")).val('');
						}
					}
					
					if (msg) {
						if (json.data.welfareMessage) {
							try {
								var currentWelfare = json.data.welfareMessage;
								var cache_welfareid = localStorage.welfareid;
								if (cache_welfareid == null || cache_welfareid == 'null') {
									localStorage.welfareid = currentWelfare.id;
									dlm.sendRequest({
										"action":"/isNoticeRead.action",
										"params":{
											noticeid: currentWelfare.id
										},
										"async":true,
										"success":function(ret){
											var read = ret.data.read;
											if (read) {
												$(msg.getElementByXid("activity")).find(".message-info").html(currentWelfare.title);
												$(msg.getElementByXid("activity")).find("dd > h2 > em").remove();
											}
											else {
												$(".msgtip").show();
												$(msg.getElementByXid("activity")).find(".message-info").html(currentWelfare.title);
												$(msg.getElementByXid("activity")).find("dd > h2 > em").remove();
												$(msg.getElementByXid("activity")).find("dd > h2").append("<em>&#xe649;</em>");
											}
										}
									});
								}
								else if (cache_welfareid == currentWelfare.id) {
									//福利消息一致
								}
								else {
									localStorage.welfareid = currentWelfare.id;
									$(".msgtip").show();
									$(msg.getElementByXid("activity")).find(".message-info").html(currentWelfare.title);
									$(msg.getElementByXid("activity")).find("dd > h2 > em").remove();
									$(msg.getElementByXid("activity")).find("dd > h2").append("<em>&#xe649;</em>");
								}
							}
							catch (e) {
								
							}
							
						}
						else {
							localStorage.welfareid = null;
							$(msg.getElementByXid("activity")).find(".message-info").html('');
							$(msg.getElementByXid("activity")).find("dd > h2 > em").remove();
						}
						
						if (json.data.noticeMessage) {
							try{
								var currentNotice = json.data.noticeMessage;
								var cache_noticeid = localStorage.noticeid;
								if (cache_noticeid == null || cache_noticeid == 'null') {
									localStorage.noticeid = currentNotice.id;
									dlm.sendRequest({
										"action":"/isNoticeRead.action",
										"params":{
											noticeid: currentNotice.id
										},
										"async":true,
										"success":function(ret){
											var read = ret.data.read;
											if (read) {
												$(msg.getElementByXid("notice")).find(".message-info").html(currentNotice.title);
												$(msg.getElementByXid("notice")).find("dd > h2 > em").remove();
											}
											else {
												$(".msgtip").show();
												$(msg.getElementByXid("notice")).find(".message-info").html(currentNotice.title);
												$(msg.getElementByXid("notice")).find("dd > h2 > em").remove();
												$(msg.getElementByXid("notice")).find("dd > h2").append("<em>&#xe649;</em>");
											}
										}
									});
								}
								else if (cache_noticeid == currentNotice.id) {
									//两条消息一致
								}
								else {
									$(".msgtip").show();
									localStorage.noticeid = currentNotice.id;
									$(msg.getElementByXid("notice")).find(".message-info").html(currentNotice.title);
									$(msg.getElementByXid("notice")).find("dd > h2 > em").remove();
									$(msg.getElementByXid("notice")).find("dd > h2").append("<em>&#xe649;</em>");
								}
							}
							catch (e) {
								
							}
							
						}
						else {
							localStorage.noticeid = null;
							$(msg.getElementByXid("notice")).find(".message-info").html('');
							$(msg.getElementByXid("notice")).find("dd > h2 > em").remove();
						}
					}
					
					
				} else{
					if(json && (json.result == 3 || json.result == 4)){
						localStorage.removeItem("userinfo");
					}
					if(json.data){
						clearInterval(refreshMessage);
						//Alert(json.data);
						//justep.Shell.showPage("login");
					}
					localStorage.removeItem("orderNewtime");
					localStorage.removeItem("notRead");
				}
			}
		});
	};
	
	Model.prototype.loginSuccess = function(event){
//		window.location.reload();
		this.comp("mainContainer").refresh();
//		justep.Shell.showLeft();
		return;
	};
	
	//公告分享
	Model.prototype.noticeInfoShare = function(data)
	{
		var title = "【" + data.title + "】代练猫，活动不停！";
		this.shareSourceData = {
			title: data.title,
			content: data.summary,
			image: "http://cloundss.dailianmao.com/images/20170816/144.png"
		};
		delete data.summary;
		this.createShare(title,title,"noticeInfo",{"data":data});
	};
	
	//接单分享
	Model.prototype.receiveOrderShare = function(info){
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		var shareUser = userinfo == null ? "" : "，分享者ID：" + userinfo.userid;
		var title = "【" + info.areaname + " " + info.ordertitle + "，价格：" + info.unitprice + "元，单号：" + info.orderid + shareUser +"】代练猫 ，等你接单！";
		var content = "￥" + info.unitprice + "元  " + info.areaname + "\r\n快来~王者们都在代练猫接单赚钱";
		var image = "http://cloundss.dailianmao.com/images/20170816/144.png";
		if (info.gamename == '王者荣耀') {
			image = "http://cloundss.oss-cn-hangzhou.aliyuncs.com/images/2017-10/13/wzry.png";
		}
		else if (info.gamename == '英雄联盟') {
			image = "http://cloundss.oss-cn-hangzhou.aliyuncs.com/images/2017-10/13/yxlm.png";
		}
		this.shareSourceData = {
			title: info.ordertitle,
			content: content,
			image: image
		};
		this.createShare(title,title,"receiveOrder",{"orderid":info.orderid});
	};
	
	//打开分享层
	Model.prototype.createShare = function(title,remark,page,params){
		var me = this;
		function success(){
			me.showActionSheet();
			//非app环境
			if(!browser.isX5App){
				new Clipboard('.share_copy',{
				    text: function(trigger) {
				        return me.sharedata.text;
				    }
				});
			}
		}
		me.createShareData(title,remark,page,params,success);
	};
	
	//创建分享数据
	Model.prototype.createShareData = function(title,remark,page,params,fun){
		var me = this;
		dlm.sendRequest({
			"action":"/createAppShare.action",
			"params":{
				"title":title,
				"remark":remark,
				"page":page,
				"params":JSON.stringify(params),
				"device":me.getDeviceType(),
				"clienttype":me.getClientType()
			},
			"async":true,
			"success":function(json){
				if(json && json.result && json.result == "1" && json.data){
					me.sharedata = json.data;
					if(fun){
						fun();
					}
				}else if(json && json.data){
					Alert(json.data);
				}
			}
		});
	};
	
	//获得设备类型
	Model.prototype.getDeviceType = function()
	{
		return browser.deviceType;
	};
	
	//获得客户端类型
	Model.prototype.getClientType = function()
	{
		if(browser.isX5App){
			return 1;
		}
		if(browser.isWeChat){
			return 2;
		}
		if(browser.isMobile){
			return 3;
		}
		return 0;
	};
	
	Model.prototype.sharedata = {};
	Model.prototype.shareSourceData = {};
	
	//邀请
	Model.prototype.invite = function(info)
	{
		var me = this;
		dlm.sendRequest({
			"action":"/coupon/getInvitationLink.action",
			"params":{
				"device":browser.deviceType
			},
			"async":true,
			"success":function(json){
				if(json && json.result && json.result == "1" && json.data){
					me.sharedata = json.data;
					me.showActionSheet();
					//非app环境
					if(!browser.isX5App){
						new Clipboard('.share_copy',{
						    text: function(trigger) {
						        return me.sharedata.text;
						    }
						});
					}
				}else if(json && json.data){
					Alert(json.data);
				}
			}
		});
	};
	
	//复制分享内容
	Model.prototype.copyShare = function(){
		//app复制
		if(browser.isX5App){
			cordova.plugins.clipboard.copy(this.sharedata.text,function(evt){});	
		}
		this.hideActionSheet();
		Alert("复制成功");
	};
	
	//显示底部分享
	Model.prototype.showActionSheet = function(){
		var me = this;
		var mask = Zepto(me.getElementByXid("mask"));
		var weuiActionsheet = Zepto(me.getElementByXid("weui_actionsheet"));
		weuiActionsheet.addClass('weui_actionsheet_toggle');
		mask.show().addClass('weui_fade_toggle').unbind("tap").tap(function () {
			me.hideActionSheet();
		});
		Zepto(me.getElementByXid("actionsheet_cancel")).unbind("tap").tap(function () {
			me.hideActionSheet();
		});
		Zepto(".share_copy:eq(0)").unbind("tap").tap(function(){
			me.createShareDataToDb();
			me.share(0);
		});
		Zepto(".share_copy:eq(1)").unbind("tap").tap(function(){
			me.createShareDataToDb();
			me.share(1);
		});
		Zepto(".share_copy:eq(2)").unbind("tap").tap(function(){
			//插入分享到DB
			me.createShareDataToDb();
			me.copyShare();
		});
		weuiActionsheet.unbind('transitionend').unbind('webkitTransitionEnd');
		document.ontouchstart=function(){
			return false;
		};
	};
	
	//隐藏底部分享
	Model.prototype.hideActionSheet = function(){
		var me = this;
		var mask = Zepto(me.getElementByXid("mask"));
		var weuiActionsheet = Zepto(me.getElementByXid("weui_actionsheet"));
		weuiActionsheet.removeClass('weui_actionsheet_toggle');
		mask.removeClass('weui_fade_toggle');
		weuiActionsheet.on('transitionend', function () {
			mask.hide();
		}).on('webkitTransitionEnd', function () {
			mask.hide();
		});
		document.ontouchstart=function(){
			return true;
		};
	};
	
	//获得当前的参数，或指定url的参数
	Model.prototype.getQueryString = function(name,url){
		var search = window.location.search;
		if(url){
			search = url.indexOf("?") > -1 ? url.substring(url.indexOf("?")) : "";
		}
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i"); 
		var r = search.substr(1).match(reg); 
		if (r != null) return unescape(r[2]); return null; 
	};
	
	//URL分享
	Model.prototype.getUrlShare = function(event){
		//获取URL内容
		var share_key = this.getQueryString("share_key");
		if(share_key){
			this.openShare(share_key,2);
		}
	};
	
	//URL打开
	Model.prototype.getUrlOpen = function(event){
		//获取URL内容
		var page = this.getQueryString("page");
		var params = this.getQueryString("params");
		if(page && params){
			dlm.goPage(page,JSON.parse(params));
		}
	};
	
	Model.prototype.saveLocalRegisteParams = function()
	{
		var me = this;
		var registert_from = me.getQueryString("registert_from");
		if (registert_from) {
			localStorage.setItem("registert_from", registert_from);
		}
		var lb_outerlink = me.getQueryString("lb_outerlink");
		if (lb_outerlink) {
			localStorage.setItem("lb_outerlink", lb_outerlink);
		}
		var source_type = me.getQueryString("source_type");
		if (source_type) {
			localStorage.setItem("source_type", source_type);
		}
	};
	
	
	//复制分享
	Model.prototype.getCopyShare = function(event){
		var me = this;
		//app内获取剪切板
		cordova.plugins.clipboard.paste(function(text){
			if(text && text.indexOf("￥") > -1 && text.indexOf("代练猫") > -1){
				text = text.substring(text.indexOf("￥")+1);
				if(text.indexOf("￥") > -1){
					var share_key = text.substring(0,text.indexOf("￥"));
					me.openShare(share_key,1);
					//获取分享后把分享内容清空，避免重复分享
					cordova.plugins.clipboard.copy("",function(evt){});	
				}
			}
		});	
	};
	
	Model.prototype.openShare = function(share_key,type){
		var me = this;
		dlm.sendRequest({
			"action":"/getAppShare.action",
			"params":{
				"share_key":share_key,
				"device":me.getDeviceType(),
				"clienttype":me.getClientType(),
				"sharetype":type
			},
			"async":true,
			"success":function(json){
				if(json && json.result && json.result == "1" && json.data){
					
					var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
					if (!userinfo) {
						var shareUserid = json.data.userid || 'NOUSER';
						localStorage.setItem("lb_outerlink", "SHARE-" + share_key + "-" + shareUserid);
						localStorage.setItem("registert_from", "2");
						localStorage.setItem("source_type", "SHARE");
					}
					
					me.cindex = me.openDiv(
						"",json.data.remark,['立即查看', '取消'],"6",
						function(){
							layer.close(me.cindex);
							var page = json.data.page;
							var params = JSON.parse(json.data.params);
							// 链接分享 要跳转到链接 分享页面
							if (page == 'noticeInfo') {
								if (params.data && params.data.islinkurl == '1') {
									page = "openUrl";
								}
							}
							justep.Shell.closePage(page);
							setTimeout(function(){
								justep.Shell.loadPage(page,
									function(){
										justep.Shell.showPage(page);
										if(type == 2 && !browser.isX5App){
											if (!browser.isIOS) {
												$(me.getElementByXid("loadAppDownload")).show();
												Zepto(".closeApp").tap(function(){
													//关闭底部下载APP窗口
													$(me.getElementByXid("loadAppDownload")).hide();
												});
												Zepto(".downloadApp").tap(function(){
													//开发执行下载方法
													location.href = "http://www.dailianmao.com/htmlpage/appdownloadNew.html";
												});
											}
											
										}
									}
								,params);
							},500);
							
						}
					);
				}else if(json && json.data){
					Alert(json.data);
				}
			}
		});
	};
	
	Model.prototype.createShareDataToDb = function()
	{
		//把分享信息插入DB	
		var me = this;
		if (me.sharedata && me.sharedata.sharekey) {
			dlm.sendRequest({
				"action":"/createAppShare.action",
				"params":{
					"share_key": me.sharedata.sharekey
				},
				"async":true,
				"success":function(json){
					
				}
			});
		}
		
	};
	
	Model.prototype.qqShare = function(params) 
	{
		var success = function(result) {
	    	 Alert("分享成功");
	    };
	    var error = function(result) {
	    	Alert(JSON.stringify(result));
	    };
	    var args = {
	    	url			: utils.getShareUrl(params.url),
	    	title		: params.title,
	    	description	: params.content,
	    	imageUrl	: params.image,
	    	appName		: "share"
	    };
	    navigator.QQ.shareToQQ(success, error, args);
	};//分享到qq联系人
	
	Model.prototype.weixinShare = function(params) 
	{
	    var success = function(result) {
	    	 Alert("分享成功");
	    };
	    var error = function(result) {
	    	Alert(JSON.stringify(result));
	    };
	    var message = {
	    	media			: {webpageUrl: utils.getShareUrl(params.url)},
	    	title			: params.title,
	    	description		: params.content,
	    	mediaTagName 	: "呆脸猫",
	    	thumb 			: params.image
	    };
	    var args = {
	    	message : message,
		    scene : navigator.weixin.Scene.SESSION	
	    };
	    navigator.weixin.share(args, success, error);
	};//分享到微信联系人
	
	//分享
	Model.prototype.share = function(index){
		var me = this;
		//app复制
		if(browser.isX5App){
			cordova.plugins.clipboard.copy(me.sharedata.text,function(evt){});	
		}
		me.hideActionSheet();
		me.isopen = "0";
		me.cindex = me.openDiv(
			"",me.sharedata.text,['去粘贴', '不分享'],"5",
			function(){
				if(me.isopen == "1"){
					return;
				}
				me.isopen = "1";
				setTimeout(function(){
					layer.close(me.cindex);
					//app打开
					if(browser.isX5App){
//						try{
//							var params = me.shareSourceData;
//							params.url = me.sharedata.url;
//							me.shareSourceData = {};
//							if (index == 0) {
//								me.weixinShare(params);
//							}
//							else {
//								me.qqShare(params);
//							}
//							
//						}catch(err){
//							
//						}
						
						try {
							var opencode = index == 0 ? me.sharedata.open_wx_code : me.sharedata.open_qq_code;
							cordova.plugins.OpenApp.open(["551488263961930017855001","1",opencode], 
								function(success){
								
								},
								function(error){
									//使用第二种包名登陆
									opencode = index == 0 ? me.sharedata.open_wx_code : me.sharedata.open_qq_code2;
									cordova.plugins.OpenApp.open(["551488263961930017855001","1",opencode], 
										function(success){
										},
										function(error){
											Alert("跳转失败，请手动复制");
										}
									);
								}
							);
							
						}catch(e) {
							var scheme = "";
							if(index == 0){
								scheme = "weixin://";
							}else if(index == 1){
								if(browser.isAndroid){
									scheme = "mqqwpa://im/chat?chat_type=wpa&uin=返回好友列表粘贴&version=1";
								}else{
									scheme = "mqqwpa://";
								}
							}
							location.href=scheme;
						}
					}else{
						//跳转
						var scheme = "";
						if(index == 0){
							scheme = "weixin://";
						}else if(index == 1){
							if(browser.isAndroid){
								scheme = "mqqwpa://im/chat?chat_type=wpa&uin=返回好友列表粘贴&version=1";
							}else{
								scheme = "mqqwpa://";
							}
						}
						location.href=scheme;
					}
				},200);
			},
			function(){
				//非APP环境，兼容多种情况复制
				if(!browser.isX5App){
					$(".layermbtn span").eq(1).attr("data-clipboard-target",".share_copy_text");
					$(".layermbtn span").eq(1).addClass("share_copy");
					new Clipboard('.share_copy');
				}
			}
		);
	};
	
	Model.prototype.openDiv = function(title,content,other,type,fun,fun2){
		var _html = '';
		if(type == 2){
			_html += '<div class="ye-box"><div class="ye-box-header">'+
						'<em class="iconfont" style="right:0;left:inherit;">&#xe601;</em>'+
						'<h2 class="title">'+title+'</h2>'+
					'</div>';
			_html += '<div class="ye-box-con">'+content+'</div>'+
					'<div class="btn-block" style="margin: 0.3rem 0 0.6rem 0;">'+
				    	'<p><a class="button-blue">'+other+'</a></p>'+
				    '</div>'+
				'</div>';
		}else if(type == 5){
			_html += '<div style="height:2.6rem;">'+
						'<img src="http://static.dailianmama.com/app_dlmm/images/share_logo.png" width="30%">'+
					'</div>'+
					'<h4 class="share_p"><span class="share_p_span">您的分享口令已生成</span></h4>'+
					'<div class="share_detail">'+
						'<textarea style="width:90%;height:3.8rem;border:0;margin-top:0.5rem;" class="share_copy_text" readonly>'+ content+'</textarea>'+
					'</div>';
		}else if(type == 6){
			_html += '<div style="height:2.4rem;">'+
						'<img src="http://static.dailianmama.com/app_dlmm/images/openshare_logo.png" width="23%">'+
					'</div>'+
					'<h4 class="openShare_p"><span class="share_p_span">去打开分享口令</span></h4>'+
					'<div class="share_detail">'+
						'<p class="share_content">'+content+'</p>'+
					'</div>';
		}
		var cindex;
		if(type != 2){
			cindex = layer.open({
			    content: _html,
			    btn: other,
			    className:'sharePopup',
			    success:function(){
			    	setTimeout(function(){
				    	if(fun2){
							fun2();
						}
					},500);
			    },
		    	yes: function(index){
		    		if(fun){
		    			fun();
		    		}
			    }
			});
		}else{
			cindex = layer.open({
				content:_html,
				className:"ye-type",
				shadeClose: false,
				success: function(){
					setTimeout(function(){
						$(".ye-box-header").find("em.iconfont").click(function(){
							layer.closeAll();
						});
						$(".ye-box .btn-cancel").click(function(){
							layer.closeAll();
						});
						$(".ye-box .input").focus(function(){
							$(".ye-box .msg").html("&nbsp;");
						});
						$(".ye-box .input").trigger('click');
						$(".ye-box .btn-sure").click(function(){
							fun();
						});
						$(".ye-box .button-blue").click(function(){
							var text = $(".ye-box .input").val();
							fun(text);
						});
						if(fun2){
							fun2();
						}
					},500);
				}
			});
		}
		return cindex;
	};
	
	$(window).on("message", function(e) {
		var dlm = require("$UI/dlapp/js/dlm");
	    var data = e.originalEvent.data || '';
	    data = data.toLowerCase();
	    if (data == 'coupon.clickreceive') {
	    	var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
			//校验登录状态
			if(!userinfo){
				var url = '$UI/dlapp/page/register/register.w';
				justep.Shell.showPage(url);
				return;
			}
			mjh();
	    }
	});
	
	// 失败
	function receiveCouponError(errorMsg) {
		$("#CouponErrorMsg").html(errorMsg);
		layer.open({
			type: 1,
			className:'tc',
			shadeClose:true,
			content: $(".receiveCouponError").html(),
			success: function(){
			    $(".pop-close").click(function(){layer.closeAll();});
			} 
		});
	};
	// 没机会
	function mjh() {
		layer.open({
			type: 1,
			className:'tc',
			shadeClose:true,
			content: $(".mjh").html(),
			success: function(){
			    $(".pop-close").click(function(){layer.closeAll();});
			} 
		});
	};
	//获得物品
	function hdwp() {
		layer.open({
			type: 1,
			className:'tc',
			shadeClose:true,
			content: $(".hdwp").html(),
			success: function(){
			    $(".pop-close").click(function(){layer.closeAll();});
			} 
		});
	};
	
	//未登陆
	function wbd() {
		layer.open({
			type: 1,
			className:'tc',
			shadeClose:true,
			content: $(".wbd").html(),
			success: function(){
			    $(".pop-close").click(function(){layer.closeAll();});
			} 
		});
	};
	
	return Model;
});

var cnzz_protocol = (("https:" == document.location.protocol) ? " https://" : " http://");document.write(unescape("%3Cspan id='cnzz_stat_icon_1260003816'%3E%3C/span%3E%3Cscript src='" + cnzz_protocol + "s95.cnzz.com/z_stat.php%3Fid%3D1260003816' type='text/javascript'%3E%3C/script%3E"));