define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	
	var Model = function(){
		this.callParent();
	};

	Model.prototype.back = function(event){
		this.close();
	};

	Model.prototype.onloadModel_BM = function(event){
		var me = this;
		$("#accountList").empty();
		dlm.sendRequest({
			"action" : "/finance/getBankAccounts.action",
			"params" : {
				
			},
			"success" : function(json) {
				//alert(JSON.stringify(json.data));
				var count = parseInt(json.data.length);
				if(count>0){
					for(var index in json.data){
						var bankaccount = json.data[index];
						var isdefault = bankaccount.isdefault;
						var fbaid = bankaccount.fbaid;
						var accountnum = bankaccount.accountnum;
						var bankname = bankaccount.bankname;
						var accounttype = bankaccount.accounttype;
						var bankDiv;
						if(accounttype=="1"){	//银行卡
							accountnum = "**** **** **** " + accountnum.substring(accountnum.length-4);
							bankDiv = "<div class=\"bank-card-item\"><a href=\"javascript:void(0)\" data=\""+bankaccount.fbaid+"\" class=\"btn-remove\">删除</a>"+
										"<div class=\"bank-card-top\"><dl class=\"clearfix\">"+
										"<dt><em class=\"iconfont\">&#xe627;</em></dt><dd>"+
										"<h2>"+bankname+"</h2><p>储蓄卡</p></dd></dl></div>"+
										"<div class=\"bank-card-bot\"><em>"+accountnum+"</em></div>"+
										"<em class=\"iconfont bank-logo\"></em></div>";
						} else if(accounttype=="3"){	//支付宝
							if(accountnum.indexOf("@")>-1){
								accountnum = accountnum.substring(0,3) + "***" +accountnum.substring(accountnum.indexOf("@"));
							} else{
								accountnum = accountnum.substring(0,3) + "***" + accountnum.substring(accountnum.length-4);
							}
							bankDiv = "<div class=\"bank-card-item alipay\"><a href=\"javascript:void(0)\" data=\""+bankaccount.fbaid+"\" class=\"btn-remove\">删除</a>"+
										"<div class=\"bank-card-top\"><dl class=\"clearfix\">"+
										"<dt style=\"background:#0060c0;\"><em class=\"iconfont\">&#xe629;</em></dt>"+
										"<dd style=\"margin-top: 0.4rem;\"><h2>支付宝</h2></dd></dl></div>"+
										"<div class=\"bank-card-bot\"><em>"+accountnum+"</em></div>"+
										"<em class=\"iconfont bank-logo\"></em></div>";
						}
						$("#accountList").append(bankDiv);
					}
					//删除提现账户
					$('.btn-remove').click(function(){
						var fbaid  = $(this).attr("data");
						me.confirm("确认删除该提现账户？", fbaid);
					});
				}
			}
		});
		
		var myScroll;
		var def = function(e){e.preventDefault();}
		function loaded () {
			//加载默认的事件
			myScroll = new IScroll('#ba_wrapper',{
				bounce:false,
				momentum:false,
				scrollY:false
			});
			document.addEventListener('touchmove',def,false);
		};
		
		//点击添加账户
		$(".add-card-btn").click(function(event){
			event.stopPropagation(); //阻止事件冒泡
			loaded(); // 创建活动菜单
			var mmenuhei = $("#ba_choose_aut").height();
			DownSlide(mmenuhei);
			
			$(".cancel-choose").on('tap', function(event){
				UpSlide(def, myScroll); //关闭上滑菜单
			});
			$(document).click(function(event){
				UpSlide(def, myScroll); //关闭上滑菜单
			});
			$(".offer-float").click(function(event){
				event.stopPropagation();
			});
			
			$("#ba_add_zfb").on('tap', function(event){
				var url = '$UI/dlapp/page/finance/toAddZfbaccount.w';
				var params = {
					reloadParent:function(){me.onloadModel_BM();}
		        };
				justep.Shell.showPage(url, params);
			});
			
			$("#ba_add_bank").on('tap', function(event){
				var url = '$UI/dlapp/page/finance/toAddBankaccount.w';
				var params = {
					reloadParent:function(){me.onloadModel_BM();}
		        };
				justep.Shell.showPage(url, params);
			});
			
		});
	};

	/*//添加银行卡
	Model.prototype.toAddBankaccount = function(event){
		var me = this;
		var url = '$UI/dlapp/page/finance/toAddBankaccount.w';
		var params = {
			reloadParent:function(){me.onloadModel_BM();}
        };
		justep.Shell.showPage(url, params);
	};
	
	//添加支付宝
	Model.prototype.toAddZfbaccount = function(event){
		var me = this;
		var url = '$UI/dlapp/page/finance/toAddZfbaccount.w';
		var params = {
			reloadParent:function(){me.onloadModel_BM();}
        };
		justep.Shell.showPage(url, params);
	};*/
	
	Model.prototype.deleteBankaccount = function(fbaid){
		var me = this;
		dlm.sendRequest({
			"action" : "/finance/deleteBankAccount.action",
			"params" : {
				fbaid :fbaid
			},
			"success" : function(json) {
				if(json.result=="1"){
					me.onloadModel_BM();
				} else{
					Alert("系统错误，请稍后重试");
				}
			}
		});
	};
	
	Model.prototype.confirm=function(tips, fbaid){
		var me = this;
		$(".ye-box-text").html(tips);
		var _html= $(".ye-box-wrap").html();
		layer.open({
			content:_html,
			className:"ye-type",
			shadeClose: false,
			success: function(){
				$(".ye-box .btn-cancel").click(function(){
					layer.closeAll();
				});
				$(".ye-box .btn-sure").click(function(){
					layer.closeAll();
					me.deleteBankaccount(fbaid);
				})
			}
		});
	};
	
	return Model;
});