define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var Model = function(){
		this.callParent();
	};
	
	Model.prototype.loadFinanceManager = function(event){
		dlm.sendRequest({
			"action" : "/finance/getAccountInfo.action",
			"params" : {
				
			},
			"success" : function(json) {
				$("#fm_amount").html(json.data.A);
				$("#fm_freeze").html(json.data.B);
			}
		});
	};
	
	Model.prototype.checkLimit=function(limittype){
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		if(userinfo!=null && userinfo.menuid && userinfo.menuid!==""){
			if(userinfo.menuid.indexOf(limittype)<0){
				Alert("对不起，您没有该操作权限");
				return false;
			}
		}
		return true;
	};
	
	Model.prototype.charge = function(event){
		if(!this.checkLimit("10001")){
			return;
		} else{
			var me = this;
			var url = '$UI/dlapp/page/finance/toAddCharge.w';
	        var params = {
	            reloadParent:function(){me.loadFinanceManager();}
	        };
			justep.Shell.showPage(url,params);
		}
	};
	
	Model.prototype.tixian = function(event){
		if(!this.checkLimit("10002")){
			return;
		}
		var me = this;
		dlm.sendRequest({
			"action" : "/toApprove.action",
			"params" : {
				
			},
			"success" : function(json) {
				var result = json.result;
				if(result=="1"){
					var url = '$UI/dlapp/page/finance/toAddExtractcash.w';
					var params = {
			            reloadParent:function(){me.loadFinanceManager();}
			        };
					justep.Shell.showPage(url,params);
				} else if(result=="2"){
					if(json.data.message.indexOf("实名认证")>0){
						me.confirm("请先进行实名认证");
					} else{
						var message = json.data.message;
						if(message.indexOf("封停")>-1){
							layer.open({
								content: '<div style="text-align:left;">'+message.replace(new RegExp('\n','gm'),'<br/>')+'</div>',
								shade:false,
								style: 'background-color:rgba(0,0,0,0.7);color:#fff;border:none;text-align:center;width:auto; margin:0 0.6rem;',
								time: 4
							});
						} else{
							Alert(message);
						}
					}
				}
			}
		});
	};
	
	Model.prototype.back = function(event){
		this.params.reloadParent();
		this.close();
	};
	
	Model.prototype.bankaccountManager = function(event){
		if(!this.checkLimit("10002")){
			return;
		}
		var me = this;
		dlm.sendRequest({
			"action" : "/toApprove.action",
			"params" : {
				
			},
			"success" : function(json) {
				var result = json.result;
				if(result=="1"){
					var url = '$UI/dlapp/page/finance/bankaccountManager.w';
					justep.Shell.showPage(url);
				}else if(result=="2"){
					if(json.data.message){
						if(json.data.message.indexOf("实名认证")>0){
							me.confirm("请先进行实名认证");
						} else{
							var message = json.data.message;
							if(message.indexOf("封停")>-1){
								layer.open({
									content: '<div style="text-align:left;">'+message.replace(new RegExp('\n','gm'),'<br/>')+'</div>',
									shade:false,
									style: 'background-color:rgba(0,0,0,0.7);color:#fff;border:none;text-align:center;width:auto; margin:0 0.6rem;',
									time: 4
								});
							} else{
								Alert(message);
							}
						}
					}
				}
			}
		});
	};
	
	Model.prototype.financeList = function(event){
		var url = '$UI/dlapp/page/finance/financeList.w';
		justep.Shell.showPage(url);
	};
	
	Model.prototype.freezeList = function(event){
		var url = '$UI/dlapp/page/finance/freezeList.w';
		justep.Shell.showPage(url);
	};
	
	Model.prototype.chargeList = function(event){
		var url = '$UI/dlapp/page/finance/chargeList.w';
		justep.Shell.showPage(url);
	};
	
	Model.prototype.mentionList = function(event){
		var url = '$UI/dlapp/page/finance/mentionList.w';
		justep.Shell.showPage(url);
	};
	
	Model.prototype.confirm=function(tips){
		var me = this;
		$(".ye-box-text").html(tips);
		var _html= $(".ye-box-wrap").html();
		layer.open({
			content:_html,
			className:"ye-type",
			shadeClose: false,
			success: function(){
				$(".ye-box .btn-cancel").click(function(){
					layer.closeAll();
				});
				$(".ye-box .btn-sure").click(function(){
					layer.closeAll();
					var url = '$UI/dlapp/page/personal/approve.w';
					var params = {
			            reloadParent:function(){me.loadFinanceManager();}
			        };
					justep.Shell.showPage(url,params);
					
				})
			}
		});
	};
	
	return Model;
});