define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	
	var Model = function(){
		this.callParent();
	};

	Model.prototype.onloadBankaccount = function(event){
		var me = this;
		$("#accountList").empty();
		dlm.sendRequest({
			"action" : "/finance/getBankAccounts.action",
			"params" : {
				
			},
			"success" : function(json) {
				var count = parseInt(json.data.length);
				if(count>0){
					for(var index in json.data){
						var bankaccount = json.data[index];
						var isdefault = bankaccount.isdefault;		//是否为默认
						var fbaid = bankaccount.fbaid;				
						var accountnum = bankaccount.accountnum;	//账号
						var accounttype = bankaccount.accounttype;	//账号类型    1：银行   2：支付宝
						if(accountnum!=""){
							if(accounttype=="1"){	//银行卡
								accountnum = "**" + accountnum.substring(accountnum.length-4);
							} else if(accounttype=="3"){
								if(accountnum.indexOf("@")>-1){
									accountnum = accountnum.substring(0,3) + "***" +accountnum.substring(accountnum.indexOf("@"));
								} else{
									accountnum = accountnum.substring(0,3) + "***" + accountnum.substring(accountnum.length-4);
								}
							}
						}
						var bankDiv = "<li class=\"info-title "+(isdefault=="1"?"on":"")+"\" data=\""+fbaid+"\"><p>"+bankaccount.bankname+"("+accountnum+")</p>"+
								"<em class=\"iconfont\">&#xe633;</em></li>";
						$("#accountList").append(bankDiv);
					}
					$(".info-title").click(function(){
						$(".info-title").removeClass("on");
						$(this).addClass("on");
						dlm.sendRequest({
							"action" : "/finance/setDefaultAccount.action",
							"params" : {
								fbaid:$(this).attr("data")
							},
							"success" : function(json) {
								me.params.reloadParent();
								me.close();
							}
						});
					});
				}
			}
		});
		
		
		var myScroll;
		var def = function(e){e.preventDefault();}
		function loaded () {
			//加载默认的事件
			myScroll = new IScroll('#sb_wrapper',{
				bounce:false,
				momentum:false,
				scrollY:false
			});
			document.addEventListener('touchmove',def,false);
		};
		
		//点击添加账户
		$(".add-aut").click(function(event){
			event.stopPropagation(); //阻止事件冒泡
			loaded(); // 创建活动菜单
			var mmenuhei = $("#sb_choose_aut").height();
			DownSlide(mmenuhei);
			
			$(".cancel-choose").on('tap',function(event){
				UpSlide(def, myScroll); //关闭上滑菜单
			});
			$(document).click(function(event){
				UpSlide(def, myScroll); //关闭上滑菜单
			});
			$(".offer-float").click(function(event){
				event.stopPropagation();
			});
			
			$("#sb_add_zfb").on('tap', function(event){
				var url = '$UI/dlapp/page/finance/toAddZfbaccount.w';
				var params = {
					reloadParent:function(){me.onloadBankaccount();}
		        };
				justep.Shell.showPage(url, params);
			});
			
			$("#sb_add_bank").on('tap', function(event){
				var url = '$UI/dlapp/page/finance/toAddBankaccount.w';
				var params = {
					reloadParent:function(){me.onloadBankaccount();}
		        };
				justep.Shell.showPage(url, params);
			});
			
		});
	};

	/*//添加银行卡
	Model.prototype.toAddBankaccount = function(event){
		var me = this;
		var url = '$UI/dlapp/page/finance/toAddBankaccount.w';
		var params = {
			reloadParent:function(){me.onloadBankaccount();}
        };
		justep.Shell.showPage(url, params);
	};
	
	//添加支付宝
	Model.prototype.toAddZfbaccount = function(event){
		var me = this;
		var url = '$UI/dlapp/page/finance/toAddZfbaccount.w';
		var params = {
            reloadParent:function(){me.onloadBankaccount();}
        };
		justep.Shell.showPage(url, params);
	};*/

	Model.prototype.back = function(event){
		this.close();
	};

	return Model;
});