define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var browser = require("$UI/system/lib/base/browser");
	
	var Model = function()
	{
		this.callParent();
	};
	/*添加到主屏幕悬浮*/
	Model.prototype.addToScreen = function()
	{
		var html = $(".addToScreen").html();
		layer.open({
			type: 1,
			className:'addToScreen',
		    content:html,
		    fixed:false,
		    skin: 'footer',
		    success:function(layero){
		    	var index = $(layero).attr("index");
		    	$(".layermanim").find("em.close").click(function(){
		    		layer.close(index);
		    	});
		    }
		});
	};
	
	Model.prototype.showAccess = function()
	{
		//根据服务类型显示不同的入口
		var me = this;
		var serviceType = localStorage.getItem("ServiceType");
		if (serviceType == 'ReleaseOrder') {
			$(me.getElementByXid("dl-entry")).show();
			$(me.getElementByXid("finddl-new")).hide();
		}
		else if (serviceType == 'ReceiveOrder') {
			$(me.getElementByXid("dl-entry")).hide();
			$(me.getElementByXid("finddl-new")).show();
		}
		else {
			//在main中已经跳转到选择页面了，不需要再跳转到serviceType页面
			
		}
	};
	
	Model.prototype.modelLoad = function()
	{
		var me = this; 
		if (browser.isX5App) {
			if (browser.isIOS) {
	        	me.comp("panel2").setHeight("top", 63);
	        } 
		}
		me.showAccess();
        setTimeout(function(){me.openCoupon();}, 3000);
        Zepto(".newscon").FontScroll({time: 3000,num: 1});
        setTimeout(function(){
			me.loadData();
		}, 1000);
		setInterval(function(){
			me.loadData();
		}, 1800000);
		
		//M端
		if(!browser.isX5App){
			//IOS Safari添加主屏;Android提示下载
			if(browser.isIOS){
				if(browser.Safari){
					var userAgent = navigator.userAgent;
					if(userAgent.indexOf("Safari") == 123){
						me.addToScreen();
					}
				}
			}
			else {
				var lb_outerlink = localStorage.getItem("lb_outerlink");
				var userinfo = localStorage.getItem("userinfo");
				if (lb_outerlink) {
					if (userinfo && userinfo != "null") {
						$(".android-download").show();
					}
				}
				else {
					$(".android-download").show();
				}
			}	
		}
	};
	
	Model.prototype.closeDownloadPage = function(event)
	{
		/*关闭下载悬浮*/
		$(".android-download").hide();
	};
	
	Model.prototype.downloadAppClick = function(event)
	{
		var me = this;
		if (me.isMobile()) {
			//window.location.href= "http://cloundss.dailianmao.com/tool/dlm_v1.1.9.apk";
			var ua = navigator.userAgent.toLowerCase();//获取判断用的对象
			if (ua.match(/MicroMessenger/i) == "micromessenger" || ua.match(/WeiBo/i) == "weibo" || ua.match(/QQ/i) == "qq") {
			    //在微信中打开、在新浪微博客户端打开、在QQ空间打开
				var _html = $(me.getElementByXid("downloadTips")).html();
				layer.open({
			    	className:"wstore-share-tip",
					content: _html,
					shadeClose:false,
					success: function(layero){
						var index = $(layero).attr("index");
					    $(".wstore-share").click(function(){
					    	layer.close(index);
					    });
					    $(".layermchild").css("background-color","transparent");
					    $(".laymshade").css("background","rgba(0,0,0,.9);");
					    $(".section").css("display","block");
					}     
				});
			}
		}
	};
	
	Model.prototype.isMobile = function()
	{
		var u = navigator.userAgent;
		return !!u.match(/AppleWebKit.*Mobile.*/);
	};
	
	Model.prototype.openClickCouponPage = function()
	{
		var me = this;
		dlm.goPage("advert", {url: me.couponIcon.link, title: me.couponIcon.title});
	};
	
	Model.prototype.loadCouponIcon = function(couponIcon)
	{
		var me = this;
		if (couponIcon == null) {
			me.couponIcon = null;
			$("index-hb").hide();
			return;
		}
		me.couponIcon = couponIcon;
		$(".index-hb").find("img").attr("src", couponIcon.img || 'http://cloundss.oss-cn-hangzhou.aliyuncs.com/dlm/images/hb-index-new.gif');
		$(".index-hb").show();
	};
	
	Model.prototype.loadData = function()
	{
		var me = this;
		dlm.sendRequest({
			"action":"/app/getHomepageData.action",
			"params":{},
			"success" : function(json){
				if (json && json.result && json.result == "1"){
					var data = json.data;
					me.loadAdvert(data.adverts);
					me.loadRecentOrders(data.orders);
					me.loadPublishNumber(data.publishOrderNumber);
					me.loadReviewContent(data.reviewContent);				
				}				
			}				
		});
	};
	
	Model.prototype.openCoupon = function()
	{
		var me = this;
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		//校验登录状态
		if(!userinfo){
			return;
		}
		dlm.sendRequest({
			"action":"/coupon/getPushCouponToClient.action",
			"params":{},
			"success" : function(json){
				if (json && json.result && json.result == "1"){
					var data = json.data;
					if (data != null) {
//							var data = [
//			{id: '0001', coupon_id: '1001', userid: '111292233', template_amount: 5, template_name: '端午节日活动', template_order_amount: 50, 
//				template_apply_platform: '1102', template_apply_game:'G603', template_apply_role:'0', template_apply_user:'1301', 
//				template_apply_platform_name: 'app', template_apply_game_name:'英雄联盟', template_apply_user_name:'全部', template_apply_bussiness_name:'张三',
//				delivery_tag: '主动领取', usetime_begin: '2017-07-01 10:00:00', usetime_end: '2017-08-01 10:00:00', status: '2', receiver_type: '1', receiver_type_class: 'ling', receiver_type_name:'领'
//			},
//			{id: '0001', coupon_id: '1001', userid: '111292233', template_amount: 10, template_name: '王者荣耀订单返利', template_order_amount: 100,
//				template_apply_platform: '1103', template_apply_game:'G604', template_apply_role:'1',template_apply_user:'1302',
//				template_apply_platform_name: 'PC客户端',template_apply_game_name:'王者荣耀',template_apply_user_name:'英雄联盟优质',template_apply_bussiness_name:'李四',
//				delivery_tag: '平台赠送', usetime_begin: '2017-07-01 10:00:00', usetime_end: '2017-08-01 10:00:00', status: '3', receiver_type: '2', receiver_type_class: 'fan', receiver_type_name:'返'
//			},
//			{id: '0001', coupon_id: '1001', userid: '111292233', template_amount: 20, template_name: '端午节日活动', template_order_amount: 100, 
//				template_apply_platform: '1102,1103', template_apply_game:'G609', template_apply_role:'2',template_apply_user:'1301',
//				template_apply_platform_name: 'app,PC客户端', template_apply_game_name:'外服英雄联盟',template_apply_user_name:'全部',template_apply_bussiness_name:'张三,李四',
//				delivery_tag: '邀请奖励', usetime_begin: '2017-07-01 10:00:00', usetime_end: '2017-08-01 10:00:00', status: '2', receiver_type: '3', receiver_type_class: 'zeng', receiver_type_name:'赠'
//			},
//			{id: '0001', coupon_id: '1001', userid: '111292233', template_amount: 15, template_name: '王者荣耀订单返利', template_order_amount: 20, 
//				template_apply_platform: '1102', template_apply_game:'G603,G604,G609', template_apply_role:'0',template_apply_user:'1302',
//				template_apply_platform_name: 'app',template_apply_game_name:'英雄联盟,王者荣耀,外服英雄联盟',template_apply_user_name:'英雄联盟优质',template_apply_bussiness_name:'',
//				delivery_tag: '平台赠送', usetime_begin: '2017-07-01 10:00:00', usetime_end: '2017-08-01 10:00:00', status: '2', receiver_type: '4', receiver_type_class: 'dui', receiver_type_name:'兑'
//			},
//			{id: '0001', coupon_id: '1001', userid: '111292233', template_amount: 10, template_name: '端午节日活动', template_order_amount: 50, 
//				template_apply_platform: '1103', template_apply_game:'G604', template_apply_role:'2',template_apply_user:'1302',
//				template_apply_platform_name: 'PC客户端',template_apply_game_name:'王者荣耀',template_apply_user_name:'英雄联盟优质',template_apply_bussiness_name:'张三,李四',
//				delivery_tag: '客服返还', usetime_begin: '2017-07-01 10:00:00', usetime_end: '2017-08-01 10:00:00', status: '2', receiver_type: '1', receiver_type_class: 'ling', receiver_type_name:'领'
//			},
//			{id: '0001', coupon_id: '1001', userid: '111292233', template_amount: 5, template_name: '端午节日活动', template_order_amount: 30, 
//				template_apply_platform: '1102', template_apply_game:'G603', template_apply_role:'1',template_apply_user:'1301',
//				template_apply_platform_name: 'app',template_apply_game_name:'英雄联盟',template_apply_user_name:'全部',template_apply_bussiness_name:'张三,李四',
//				delivery_tag: '活动奖励', usetime_begin: '2017-07-01 10:00:00', usetime_end: '2017-08-01 10:00:00', status: '3', receiver_type: '1', receiver_type_class: 'ling', receiver_type_name:'领'
//			}
//		];
						var buffer = [];
						for (var i = 0; i < data.length; i++) {
							var coupon = data[i];
							buffer.push('<div class="couponew iconfont ' + coupon.receiver_type_class + '">'						);
							buffer.push(	'<div class="cirle"></div>'																);
							buffer.push(	'<div class="cirri"></div>'																);
							buffer.push(	'<div class="coupontop">'																);
							buffer.push(		'<div class="square"><span>' + coupon.receiver_type_name + '</span></div>'			);
							buffer.push(		'<div class="trigle"></div>'														);
							buffer.push(		'<dl>'																				);
							buffer.push(			'<dt>'																			);
							buffer.push(				'<h3><span>￥</span>' + coupon.template_amount + '</h3>'						);
							buffer.push(				'<p>满' + coupon.template_order_amount + '元可用</p>'						);
							buffer.push(			'</dt>'																			);
							buffer.push(			'<dd>'																			);
							buffer.push(				'<h3>' + coupon.template_name + '</h3>'										);
							buffer.push(				'<p>' 
															+ (coupon.usetime_begin == null ? '' : coupon.usetime_begin.replace(/-/g, '.').replace(/\s.*$/, ''))
															+ '-'
															+ (coupon.usetime_end == null ? '' : coupon.usetime_end.replace(/-/g, '.').replace(/\s.*$/, ''))
														+ '</p>'																	);
							buffer.push(			'</dd>'																			);
							buffer.push(		'</dl>'																				);
							if (coupon.userid == null) {
								buffer.push(		'<a href="javascript:void(0)" class="usenow">立即领取</a>'						);
							}
							else {
								buffer.push(		'<a href="javascript:void(0)" class="usenow using">立即使用</a>'					);
							}
							buffer.push(	'</div>'																				);
							buffer.push('</div>'																					);
						}
						$(".hbopen .hbcon .hbcon-list").html(buffer.join(""));
						if (data.length > 0) {
							me.showCoupon(data);
						}
					}			
				}				
			}				
		});
		
	};
	
	Model.prototype.showCoupon = function(data)
	{
		var me = this;
		var html = $(".hbopen").html();
		layer.open({
			type: 1,
			className: 'openhb',
			content: html,
			success: function(layero){
				var index = $(layero).attr("index");
			    $(".layermanim").find(".hbcon-list > .couponew").each(function(i){
			    	this.coupon = data[i];
			    	this.onclick = function(){
			    		var couponDom = this;
			    		var coupon = couponDom.coupon;
			    		if (coupon.userid == null) {
				    		dlm.sendRequest({
								"action":"/coupon/receiveCoupon.action",
								"params":{"couponcode": coupon.code, receivetype:"1"},
								"success" : function(json){
									if (json && json.result && json.result == "1"){
										$(couponDom).find("a").addClass("using");	
										$(couponDom).find("a").text("立即使用");		
									}
									else {
										Alert(json.data);
									}				
								}				
							});
			    		
			    		}
			    		else {
			    			layer.close(index);
			    			if (coupon.template_apply_role == '0' || coupon.template_apply_role == '1') {
								dlm.goPage("publish_index");
							}
							else {
								var mainModel = me.getParentModel();
								var btn = mainModel.getComponent("receiveButton");
								btn.fireEvent("onClick");
							}
			    		}
			    	};
			    });
			    $(".layermanim").find(".hbclose").click(function(){
			      	layer.close(index);
			    });
			}
		});
	};
	
	Model.prototype.loadReviewContent = function(content)
	{
		var me = this;
		if (content == null) {
			return;
		}
		var createtime = me.getToday();
		for (var i = 0; i < content.length && i < 20; i++) {
			var data = content[i];
			data.createtime = createtime;
			data.phone = content[i].phone.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
			if (data.touaddr == null) {
				data.touaddr = "http://uploadimg.dailianmao.com/image/DLIMGHEAD/images/LOLIcon/head001.png";
			}
		}
		me.comp("userreview").loadData(content);
	};
	
	Model.prototype.getToday = function()
	{
		var d = new Date();
		var year = d.getFullYear();
		var month = d.getMonth() + 1;
		var date = d.getDate();
		return year + "." + (month > 9 ? "" + month : "0" + month) + "." + (date > 9 ? "" + date : "0" + date);
	};
	
	Model.prototype.loadPublishNumber = function(publishNumber)
	{
		if (publishNumber == null) {
			return;
		}
		publishNumber = parseInt(publishNumber * 2.5);
		var publishInfo = "昨日累计" + publishNumber + "笔";
		$(".usersay h3 span").html(publishInfo);
	};
	
	Model.prototype.loadRecentOrders = function(orders)
	{
		if (orders != null) {
			var orderHtml = "";
			for (var i = 0; i < orders.length; i++) {
				var title = orders[i].ordertitle;
				title = title.length > 14 ? (title.substring(0, 14) + "...") : title;
				var action = orders[i].orderstatus == 1 ? " 刚刚发布了 " : " 刚刚完成了 ";
				orderHtml += "<li>"
							+		orders[i].phone.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2') + action + title + " 代练需求"
							+ "</li>";
			}
			$(".newpub").html("<ul>" + orderHtml + "</ul>");
		}
		Zepto(".newpub").FontScroll({time: 3000,num: 1});
	};
	
	Model.prototype.imgError = function(event)
	{
		var img = event.target;
		img.src = "http://uploadimg.dailianmao.com/image/DLIMGHEAD/images/LOLIcon/head001.png";
		img.onerror = null;   //控制不要一直跳动
	};
	
	window.toAdvertPage = function(id, url, title)
	{
		var dlm = require("$UI/dlapp/js/dlm");
		dlm.sendRequest({
			"action":"/appNoticeInfo.action",
			"params":{
				"noticeid":id,
				"from": "firstPage"
			},
			"success":function(json){
				if (json && json.data) {
					if (json.data.islinkurl == '2') {
						dlm.goPage("noticeInfo",{data: json.data});
					}
					else if (json.data.islinkurl == '1') {
						dlm.goPage("openUrl",{data: json.data});
					}
					else {
						dlm.goPage("openUrl",{data: json.data});
					}
				}
			}
		});
	};
	
	Model.prototype.newMessageClick = function(event)
	{
		var row = event.bindingContext.$object;
		var linktitle = row.val("linktitle");
		var linkurl = row.val("linkurl");
		dlm.goPage("advert", {url:linkurl, title:linktitle});
	};
		
	Model.prototype.loadAdvert = function(adverts)
	{	
		var me = this;
		if (me.swiper == null) {
			// 幻灯片
			var swiper = new Swiper('.swiper-container-banner', {
			    pagination: '.swiper-pagination-banner',
			    slidesPerView: 1,
				autoplay : 5000,
				autoplayDisableOnInteraction : false,
			    paginationClickable: true,
			    loop: true,
			    initialSlide :0,
			    observer: true,
			    observeParents: true
			});
			me.swiper = swiper;
		}
		if (adverts != null) {
			adverts = adverts.slice(0, 5);
//			me.comp("adverts_data").loadData(adverts.slice(0, 5));
			if (me.swiper != null) {
				me.swiper.removeAllSlides();
			}
			var buffer = [];
			for (var i = 0; i < adverts.length; i++) {
				var advertHtml = "<div class='swiper-slide'>"
							+ 		"<a onclick='toAdvertPage(\"" + adverts[i].id + "\", \"" + adverts[i].linkurl + "\", \"" + adverts[i].title + "\")' >"
							+			"<img src='" + adverts[i].imgurl + "' alt='' width='100%' style='max-height:6rem;'/>"
							+		"</a>"
							+ "</div>";
				buffer.push(advertHtml);			
			}
			me.swiper.appendSlide(buffer);	
		}
	};
	
	Model.prototype.openXl = function()
	{
		var html = $(".xlopen").html();
		layer.open({
			type: 1,
			className:'indopen',
		    content:html,
		    success:function(layero){
		      var index = $(layero).attr("index");
		      $(".layermanim").find("em").click(function(){
		      	layer.close(index);
		      });
		    }
		 });
	};
	
	Model.prototype.openAq = function()
	{
		var html = $(".aqopen").html();
		layer.open({
			type: 1,
			className:'indopen',
		    content:html,
		    success:function(layero){
		    	var index = $(layero).attr("index");
		      $(".layermanim").find("em").click(function(){
		      	layer.close(index);
		      });
		    }
		 });
	};

	Model.prototype.openSl = function()
	{
		var html = $(".slopen").html();
		layer.open({
			type: 1,
			className:'indopen',
		    content:html,
		    success:function(layero){
		    	var index = $(layero).attr("index");
		    	$(".layermanim").find("em").click(function(){
		    		layer.close(index);
		    	});
		    }
		 });
	};

	Model.prototype.openDh = function()
	{
		var html = $(".dhopen").html();
		layer.open({
			type: 1,
			className:'indopen',
		    content:html,
		    success:function(layero){
		    	var index = $(layero).attr("index");
		     	$(".layermanim").find("em").click(function(){
		     		layer.close(index);
		     	});
		    }
		 });
	};
	
	Model.prototype.publishOrder = function()
	{
		dlm.goPage("publish_index");
	};
	
	
	Model.prototype.receiveOrder = function()
	{
		var me = this;
		var mainModel = me.getParentModel();
		var btn = mainModel.getComponent("receiveButton");
		btn.fireEvent("onClick");
	};
	
	Model.prototype.receiveOrderMessage = function()
	{
		var me = this;
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		//校验登录状态
		if(!userinfo){
			dlm.goPage("login");
			return;
		}
		var mainModel = me.getParentModel();
		var btn = mainModel.getComponent("messageManageButton");
		$(".msgtip").hide();
		btn.fireEvent("onClick");
	};
	return Model;
});

