define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var MD5 = require('$UI/system/lib/base/md5');
	var Model = function() {
		this.callParent();
	};

	Model.prototype.modelLoad = function(event) {

		// 循环验证非空 并且点亮登录按钮
		var must_num = $(".must-input").length;
		$(".must-input").on('input', function() {
			$(".must-input").each(function(index) {
				var _len = $(this).val().length;
				if ($(this).parents().hasClass("password-li")) {
					if (_len < 6) {
						$(".reg-btn").find("a").removeClass("on").addClass("off");
						return false;
					}
				}
				if (index == must_num - 1) {
					$(".reg-btn").find("a").removeClass("off").addClass("on");
				}
			});

		});
		Zepto(".empty").tap(function() {
			$(".reg-btn").find("a").removeClass("on").addClass("off");
		});

	};
	/**
	 * 比较两次输入密码是否一致 一致更新密码 并且登录
	 */
	Model.prototype.updatePasswordAndLoginClick = function(event) {
		var me = this;
		// md5加密
		md5 = new MD5();
		var firstPassword = this.getElementByXid("firstPassword").value;
		var secondPassword = this.getElementByXid("secondPassword").value;
		var firstPassword_md5 = md5.hex_md5(firstPassword);
		var secondPassword_md5 = md5.hex_md5(secondPassword);
		var phonenumber = me.params.phonenumber;
		var code = me.params.code;
		if (firstPassword && secondPassword) {
			if (firstPassword === secondPassword) {
				if (firstPassword.length < 6 || secondPassword.length < 6 || firstPassword.length > 20 || secondPassword.length > 20) {

					Alert("密码长度输入错误");
					return false;
				}

				dlm.sendRequest({
					"action" : "/register/resetpassword.action",
					"params" : {
						"oldPassword" : firstPassword_md5,
						"password" : secondPassword_md5,
						"phone" : phonenumber,
						"code" : code
					},
					"success" : function(json) {
						//console.log(json);
						if (json.result == 1) {
							Alert("修改成功请登录!");
							var url = '$UI/dlapp/page/login/login.w';
							justep.Shell.showPage(url);
							
							me.getParent().loginSuccess();
							//justep.Shell.showPage("main");
						} else if(json.data && json.data.msg){
							Alert(json.data.msg=="fail"?"重置失败，请联系客服":json.data.msg);
						} else{
							Alert("密码重置失败，请联系客服");
						}

					}

				});
			} else {
				Alert("两次输入的密码不一致");
			}
		} else {
			Alert("请填写密码");
		}

	};

	Model.prototype.a1Click = function(event) {
		this.close();
	};


	return Model;
});