define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	
	var Model = function(){
		this.callParent();
	};
	
	Model.prototype.orderid = "";
	Model.prototype.lastId = 0;
	Model.prototype.beginid = "";
	Model.prototype.userid = "";
	Model.prototype.isOld = 1;
	Model.prototype.isend = 0;
	
	Model.prototype.modelInactive = function(event){
		this.comp("timer1").stop();
	};
	
	Model.prototype.getOldChatList = function(){
		var me = this;
		dlm.sendRequest({
			"action":"/chatOldList.action",
			"params":{
				"orderid":this.orderid,
				"beginid":this.beginid
			},
			"success":function(json){
				if(json && json.data && json.data.list && json.data.list.length > 0){
					var height1 = $(me.getElementByXid("window")).parent().parent()[0].scrollHeight;
					me.comp("chat").newData({"defaultValues":json.data.list,"index":0,"onSuccess":function(){
						var height2 = $(me.getElementByXid("window")).parent().parent()[0].scrollHeight;
						$(me.getElementByXid("window")).parent().parent().scrollTop(height2-height1);
						setTimeout(function(){$(me.getElementByXid("window")).parent().parent().scrollTop(height2-height1);},50);
					}});
					me.beginid = json.data.beginid
					if(json.data.isend && json.data.isend == 1){
						me.isend = 1;
						$(me.getElementByXid("loading")).hide();
					}
					setTimeout(function(){me.isOld = 0;},200);
				}
			}
		});
	};
	
	Model.prototype.getNewChatList = function(type){
		var me = this;
		dlm.sendRequest({
			"action":"/getNewChatList.action",
			"params":{
				"orderid":this.orderid,
				"lastId":this.lastId,
				"type":type
			},
			"timeout":500,
			"async":true,
			"success":function(json){
				if(json && json.data && json.data.list && json.data.list.length > 0){
					me.comp("chat").last();
					var chatid = me.comp("chat").getValue("chatid");
					if(json.data.lastId && parseInt(json.data.lastId) > parseInt(chatid)){
						me.comp("chat").newData({"defaultValues":json.data.list});
						me.lastId = json.data.lastId;
						$(me.getElementByXid("window")).parent().parent().scrollTop($(me.getElementByXid("window")).parent().parent()[0].scrollHeight);
					}
				}
			}
		});
	};
	
	Model.prototype.timer1Timer = function(event){
		this.getNewChatList("cache");
	};
	
	Model.prototype.modelLoad = function(event){
		var me = this;

		$(me.getElementByXid("window")).parent().parent().scroll(function() {
		 	var scrollTop = $(this).scrollTop();
		 	if(scrollTop <= 50 && me.isOld == 0 && me.isend == 0){
		 		me.isOld = 1;
		 		me.getOldChatList();
		 	}
		});
	};
	
	Model.prototype.chatCustomRefresh = function(event){
		this.orderid = this.params.orderid;
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		this.userid = userinfo.userid;
		var me = this;
		//查询留言记录
		dlm.sendRequest({
			"action":"/chatOldList.action",
			"params":{
				"orderid":this.orderid
			},
			"success":function(json){
				if(json && json.data && json.data.list && json.data.list.length > 0){
					me.comp("chat").loadData(json.data.list);
					me.lastId = json.data.lastId;
					me.beginid = json.data.beginid
					me.isOld = 0;
					if(json.data.isend && json.data.isend == 1){
						me.isend = 1;
						$(me.getElementByXid("loading")).hide();
					}
					//启动定时查询新留言
					me.comp("timer1").start();
					$(me.getElementByXid("window")).parent().parent().scrollTop($(me.getElementByXid("window")).parent().parent()[0].scrollHeight);
				}
			}
		});
	};
	
	//发送
	Model.prototype.sendClick = function(event){
//		if(!$(this.getElementByXid("content")).is(":focus")){
//			$(this.getElementByXid("content")).focus();
//		}
		var me = this;
		var content = $(this.getElementByXid("content")).val();
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		content = content.replace(/(^\s*)|(\s*$)/g,'');
		if(!content){
			Alert("请输入留言");
			return;
		}
		if(content.length > 50){
			Alert("单条留言不能超过50个字符~");
			return;
		}
		
		//防止重复点击
		if(me.flag1 === "1"){
			return;
		}
		me.flag1 = "1";
		
		dlm.sendRequest({
			"action":"/addChat.action",
			"params":{
				"orderid":this.orderid,
				"content":content
			},
			"success":function(json){
				if(json && json.result == "1"){
					$(me.getElementByXid("content")).val("");
					me.getNewChatList("nocache");
				}else{
					Alert("发送失败");
				}
				me.flag1 = "";
			},
			error:function(){
				Alert("发送失败");
				me.flag1 = "";
			}
		});
	};
	
	Model.prototype.backClick = function(){
		this.close();
	};
	
	Model.prototype.contentKeyup = function(event){
		var obj = event.originalEvent;
		if (obj.keyCode == "13") {
			this.sendClick();
		}
	};
	
	return Model;
});