define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var constant = require("$UI/dlapp/js/constant");
	var dlm = require("$UI/dlapp/js/dlm");
	
	var Model = function(){
		this.callParent();
	};

	Model.prototype.modelLoad = function(obj){
		var me = this;
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		var $ = jQuery,
        $list = $(this.getElementByXid("fileList")),
        $btn = $(this.getElementByXid("ctlBtn")),
        state = 'pending',
        // 优化retina, 在retina下这个值是2
        ratio = window.devicePixelRatio || 1,

        // 缩略图大小
        thumbnailWidth = 60 * ratio,
        thumbnailHeight = 60 * ratio,

        // Web Uploader实例
        uploader;

    // 初始化Web Uploader
    uploader = WebUploader.create({
        // 自动上传。
        auto: false,
        // 文件接收服务端。
        server: constant.UPLOAD_URL + '/addPicture.action',
        // 选择文件的按钮。可选。
        // 内部根据当前运行是创建，可能是input元素，也可能是flash.
        pick: this.getElementByXid("filePicker"),
        // 只允许选择文件，可选。
        accept: {
            title: 'Images',
            extensions: 'gif,jpg,jpeg,bmp,png',
            mimeTypes: 'image/*'
        },
        fileVal:'fileImage',
		sendAsBinary:true,
		duplicate:true,
		compress:{
			height:1200,
			width:1200,
			noCompressIfLarger: false
		}
    });

    // 当有文件添加进来的时候
    uploader.on( 'fileQueued', function( file) {
        var $li = $(
                '<div id="' + file.id + '" class="file-item thumbnail" >' +
                    '<img>' +
                    '<div class="up-del"><em class="iconfont">&#xe608;</em></div>' +
                '</div>'
                ),
        $img = $li.find('img');
        $list.append( $li );
		$(".up-del").on("click",function(){
            uploader.removeFile( $(this).parent().attr("id"));
            $(this).parent().remove();
            return;
        });

        // 创建缩略图
        uploader.makeThumb( file, function( error, src ) {
            if ( error ) {
                $img.replaceWith('<span>不能预览</span>');
                return;
            }

            $img.attr( 'src', src );
        }, thumbnailWidth, thumbnailHeight );
    });

    // 文件上传过程中创建进度条实时显示。
    uploader.on( 'uploadProgress', function( file, percentage ) {
    	
        var $li = $( '#'+file.id ),
            $percent = $li.find('.bbgdp');

        // 避免重复创建
        if ($percent.size() == 0 ) {
            $percent = $('<div class="progress"><div style="height:100%;background-color:#1CD51B;" class="bbgdp"></div></div>')
                    .appendTo( $li ).find('.bbgdp');
        }
        $percent.css("width",percentage*100+"%");
    });

    	// 文件上传成功，给item添加成功class, 用样式标记上传成功。
    	uploader.on( 'uploadSuccess', function( file, response) {
    		//刷新列表
    		me.comp("data1").refreshData();
    		//上传成功，清空上传栏
    		var $li = $( '#'+file.id );
    		$li.remove();
    		//全部上传成功，清空截图说明
    		if($(me.getElementByXid("fileList")).find(".file-item").size() <= 0){
    			$(me.getElementByXid("description")).val("");
    		}
	    });
	
	    // 文件上传失败，现实上传出错。
	    uploader.on( 'uploadError', function( file ) {
	        var $li = $( '#'+file.id ),
	            $error = $li.find('div.error');
	
	        // 避免重复创建
	        if ( !$error.length ) {
	            $error = $('<div class="error"></div>').appendTo( $li );
	        }
	
	        Alert('上传失败');
	    });
	    
	    uploader.on('beforeFileQueued',function(file){
	    	if($list.find(".file-item").size() >= 3){
	    		Alert("一次最多上传3个文件");
	    		return false;
	    	}
	    	if(file.size > 3*1024*1024){
	    		Alert("单个文件最大不能超过3M");
	    		return false;
	    	}
	    	if(file.name.length < 5){
	    		Alert("请选择图片文件");
	    		return false;
	    	}
	    	var hz = file.name.substring(file.name.length-5,file.name.length);
	    	if(hz.indexOf(".gif") == -1 && hz.indexOf(".jpg") == -1 
	    			&& hz.indexOf(".jpeg") == -1 && hz.indexOf(".bmp") == -1 && hz.indexOf(".png") == -1
	    			&& hz.indexOf(".GIF") == -1 && hz.indexOf(".JPG") == -1 
	    			&& hz.indexOf(".JPEG") == -1 && hz.indexOf(".BMP") == -1 && hz.indexOf(".PNG") == -1){
	    		Alert("请选择图片文件");
	    		return false;
	    	}
	    });
	
	    
	    uploader.on( 'all', function( type ) {
	        if ( type === 'startUpload' ) {
	            state = 'uploading';
	        } else if ( type === 'stopUpload' ) {
	            state = 'paused';
	        } else if ( type === 'uploadFinished' ) {
	            state = 'done';
	        }
	
	        if ( state === 'uploading' ) {
	            $btn.text('上传中...');
	        } else {
	            $btn.text('开始上传');
	        }
	    });
	    
	    $btn.on( 'click', function() {
	        if ( state === 'uploading' ) {
	            return;
	        }else{
	        	var description = $(me.getElementByXid("description")).val();
	        	if($(me.getElementByXid("fileList")).find(".file-item").size() <= 0){
	        		Alert("请选择图片");
	        		return;
	        	}
	        	if(!description){
	        		Alert("请填写截图说明");
	        		return;
	        	}
	        	if(description.length > 10){
	        		Alert("截图说明不能超过10个字");
	        		return;
	        	}
        		uploader.option( 'formData', {
        			"description":description,
        			"ticket":userinfo.ticket,
        			"orderid":me.getParent().params.orderid,
        			"appflag":"1"
        		});
        		uploader.upload();
	        }
	    });
	};
        
	Model.prototype.data1CustomRefresh = function(event){
		if(!this.isload){
			return;
		}
		var self = this;
		dlm.sendRequest({
			"action":"/toOrderTopButton.action",
			"params":{
				"orderid":self.getParent().params.orderid,
				"topage":"picture"
			},
			"trust":true,
			"success":function(json){
				if(json && json.data && json.data.info2 && json.data.info2.length > 0){
					var onSuccess = function(){
						self.comp("data1").first();
						$(self.getElementByXid("list4")).find("dt").each(function(index){
							//self.comp("data1").getValue("address")
							$(this).css("background-image","url(http://uploadimg.dailianmao.com/dl/images/dlapp/ckdt.jpg)");
							$(this).attr("data-url",self.comp("data1").getValue("address"));
							self.comp("data1").next();
						});
					}
					self.comp("data1").clear();
					self.comp("data1").newData({"defaultValues":json.data.info2,"onSuccess":onSuccess});
				}
			}
		});
	};
	
	Model.prototype.viewPicture = function(event){
		var self = this;
		var dom = event.delegateTarget;
		var _url = $(dom).data("url");
		var _img = "<img src="+_url+">";
		var Winnum = parseFloat($(window).height());
		layer.open({
			shadeClose: true,			
			content:_img+" <style>.laymshade{background-color:rgba(0,0,0, .9);}.layermcont{ padding:0 0.6rem; box-sizing:border-box; color:#fff; position:relative; display: table-cell; vertical-align: middle;}.layermcont img {position:relative; z-index:99; max-width:100%;}.layermbox0 .layermchild{width:100%; height:100%; display:table;}.layermchild{  background-color: transparent;}.layermbtn{position:fixed; height:46px; line-height:46px;border:none; bottom:0; width:100%; left:0; background:#000;z-index:9999999;}.layermbtn span:first-child{color:#fff!important; background-color: transparent;width: 100%;}.layermbtn:before{background-color: transparent;}</style>",
			btn:['返 回'],
			success:function(){
				$(".layermbtn").css("top",Winnum-46);
			}
		});
	};
        
	return Model;
});