define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var constant = require("$UI/dlapp/js/constant");
	require("$UI/system/lib/cordova/cordova");                
	require("cordova!cordova-plugin-camera");

	var Model = function(){
		this.callParent();
	};
	
	//添加图片
	Model.prototype.addPicture = function(obj){
        if(!navigator.camera){
                return;
        }
		var $list = $(this.getElementByXid("fileList"));
        var $btn = $(this.getElementByXid("ctlBtn"));
        var self = this;             
        
        navigator.camera.getPicture(onLoadImageSuccess, onLoadImageFail, { 
              mediaType : 0,//只选择图片
              quality:80,          
	          destinationType: navigator.camera.DestinationType.DATA_URL,                            
	          sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY
        });
        
        //拍照成功后回调
        function onLoadImageSuccess(imageData){
        	if($list.find(".file-item").size() >= 3){
	    		Alert("一次最多上传3个文件");
	    		return false;
	    	}
	    	if(imageData.length > 6*1024*1024){
	    		Alert("单个文件最大不能超过3M");
	    		return false;
	    	}
        	var fileid = "fileid"+justep.UUID.createUUID();
    		var $li = $(
	                '<div id="' + fileid + '" class="file-item thumbnail" >' +
	                    '<img>' +
	                    '<div class="up-del"><em class="iconfont">&#xe608;</em></div>' +
	                '</div>'
	                ),
	        $img = $li.find('img');
	        $list.append( $li );
			$(".up-del").on("click",function(){
	            $(this).parent().remove();
	        });
            $img.attr("src","data:image/jpeg;base64,"+imageData); 
        }

        function onLoadImageFail(error){
             //Alert(error);
        }
		
	};  

       //实现图片上传                
    Model.prototype.uploadPic = function(event){
    	var self = this;
    	var $list = $(this.getElementByXid("fileList"));
    	var $btn = $(this.getElementByXid("ctlBtn"));
    	var description = $(this.getElementByXid("description")).val();
    	var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
    	if($btn.text() != "开始上传"){
    		return;
    	}
		if(!description){
			Alert("请填写截图说明");
			return;
		}
		if(description.length > 10){
			Alert("截图说明不能超过10个字");
			return;
		}
		if($list.find(".file-item").size() <= 0){
			Alert("请添加图片");
			return;
		}
		$btn.text('上传中...');
    	$list.find(".file-item").each(function(index){
    		var imgdata = $(this).find("img").attr("src").replace("data:image/jpeg;base64,","");
    		var c_li = $(this);
    		
    		$.ajax({
				"type" : "POST",
				"url" : constant.UPLOAD_URL + "/addPicture.action?type=base64&appflag=1&orderid="+self.getParent().params.orderid+"&ticket="+userinfo.ticket+"&description="+description.replace("&",""),
				"crossDomain":true,
				"contentType":"application/octet-stream",
				"data" : imgdata,
				"success":function(json){
					if(json && json.result == 1){
						//上传成功删除item
			    		c_li.remove();
			    		//刷新数据
			    		if($list.find(".file-item").size() <= 0){
			    			$btn.text('开始上传');
			    			$list.html("");
			    			$(self.getElementByXid("description")).val("");
			    			self.comp("data1").refreshData();
			    		}
					}else{
						Alert("上传失败");
						setTimeout(function(){
							$btn.text('开始上传');
							self.comp("data1").refreshData();
						},1000);
					}
				},
				error : function(XMLHttpRequest, textStatus, errorThrown) {
					Alert("上传出错");
					setTimeout(function(){
						$btn.text('开始上传');
						self.comp("data1").refreshData();
					},1000);
				}
			});
    	});
    	
    };
    
    Model.prototype.data1CustomRefresh = function(event){
    	if(!this.isload){
			return;
		}
		var self = this;
		dlm.sendRequest({
			"action":"/toOrderTopButton.action",
			"params":{
				"orderid":self.getParent().params.orderid,
				"topage":"picture"
			},
			"trust":true,
			"success":function(json){
				if(json && json.data && json.data.info2 && json.data.info2.length > 0){
					var onSuccess = function(){
						self.comp("data1").first();
						$(self.getElementByXid("list4")).find("dt").each(function(index){
							//self.comp("data1").getValue("address")
							$(this).css("background-image","url(http://uploadimg.dailianmao.com/dl/images/dlapp/ckdt.jpg)");
							$(this).attr("data-url",self.comp("data1").getValue("address"));
							self.comp("data1").next();
						});
					}
					self.comp("data1").clear();
					self.comp("data1").newData({"defaultValues":json.data.info2,"onSuccess":onSuccess});
				}
			}
		});
	};
    
    Model.prototype.viewPicture = function(event){
		var self = this;
		var dom = event.delegateTarget;
		var _url = $(dom).data("url");
		var _img = "<img src="+_url+">";
		var Winnum = parseFloat($(window).height());
		layer.open({
			shadeClose: true,			
			content:_img+" <style>.laymshade{background-color:rgba(0,0,0, .9);}.layermcont{ padding:0 0.6rem; box-sizing:border-box; color:#fff; position:relative; display: table-cell; vertical-align: middle;}.layermcont img {position:relative; z-index:99; max-width:100%;}.layermbox0 .layermchild{width:100%; height:100%; display:table;}.layermchild{  background-color: transparent;}.layermbtn{position:fixed; height:46px; line-height:46px;border:none; bottom:0; width:100%; left:0; background:#000;z-index:9999999;}.layermbtn span:first-child{color:#fff!important; background-color: transparent;width: 100%;}.layermbtn:before{background-color: transparent;}</style>",
			btn:['返 回'],
			success:function(){
				$(".layermbtn").css("top",Winnum-46);
			}
		});
	};
	
	Model.prototype.modelLoad = function(obj){
	
	};

	return Model;
});