define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var MD5 = require('$UI/system/lib/base/md5');
	var Model = function() {
		this.callParent();
	};

	Model.prototype.resetPasssword = function(event) {
		var me = this;
		var oldPassword = $(this.getElementByXid("oldPassword")).val();
		var newPassword = $(this.getElementByXid("newPassword")).val();
		var renewPassword = $(this.getElementByXid("renewPassword")).val();
		var md5 = new MD5();
		if (oldPassword.trim() === "") {
			Alert("请输入原始密码");
			return;
		}
		if (newPassword.trim() === "") {
			Alert("请输入新密码");
			return;
		}
		if (renewPassword.trim() === "") {
			Alert("请再次输入新密码");
			return;
		}
		if (newPassword.trim() != renewPassword.trim()) {
			Alert("两次输入的密码不一致");
			return;
		}
		
		if (!(/^(\w){6,20}$/.test(oldPassword))) {
			Alert("请输入6-20位字母、数字、下划线");
			return false;
		}
		if (!(/^(\w){6,20}$/.test(newPassword))) {
			Alert("请输入6-20位字母、数字、下划线");
			return false;
		}
		if (!(/^(\w){6,20}$/.test(renewPassword))) {
			Alert("请输入6-20位字母、数字、下划线");
			return false;
		}
		dlm.sendRequest({
			"action" : "/updateLoginPassword.action",
			"params" : {
				oldPassword : md5.hex_md5(oldPassword),
				newPassword : md5.hex_md5(newPassword)
			},
			"success" : function(json) {
				if (json.result == "1") {
					Alert("修改成功");
					me.params.reloadParent();
					me.close();
				} else if (json.result == "2") {
					Alert(json.data);
				} else {
					Alert("修改失败");
				}
			}
		});

	};

	Model.prototype.back = function(event) {
		this.close();
	};
	/**
	 * 忘记密码
	 */
	Model.prototype.a1Click = function(event) {
		var url = '$UI/dlapp/page/login/toGetBackPassword.w';
		justep.Shell.showPage(url);
	};

	return Model;
});