define(function(require) {

	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var constant = require("$UI/dlapp/js/constant");
	var dlm = require("$UI/dlapp/js/dlm");

	var Model = function() {
		this.callParent();
	};

	var imgUrlList = [];
	Model.prototype.modelLoad = function(obj) {
		var me = this;
//		imgUrlList = [];
		var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
		
//		$(me.getElementByXid("grade-current-1")).hide();
		

		

		Zepto('.qf-input').mobiscroll().treelist({
			theme : 'mobiscroll',
			lang : 'zh',
			display : 'bottom',
			inputClass : 'sec-input',
			width : [ 160, 170 ],
			placeholder : '请选择您所在的区服',
			labels : [ 'qu', 'fu' ],
			onSelect : function(valueText, inst) {
				var quval = $('.qf-input>li').eq(inst._tempWheelArray[0]).children('span').attr('data-val');
				var fuval = $('.qf-input>li').eq(inst._tempWheelArray[0]).find('ul').find('li[data-val=' + inst._tempWheelArray[1] + ']').attr('data-val');
				$("#qu-val").val(quval);
				$("#fu-val").val(fuval);
			},
			formatResult : function(array) { //返回自定义格式结果
				qu = $('.qf-input>li').eq(array[0]).children('span');
				fu = $('.qf-input>li').eq(array[0]).find('ul').find('li[data-val=' + array[1] + ']');
				return qu.text() + ' ' + fu.text();
			}
		});

		Zepto('.grade-current').mobiscroll().treelist({
			theme : 'mobiscroll',
			lang : 'zh',
			display : 'bottom',
			inputClass : 'sec-input',
			placeholder : '请选择当前段位',
			onSelect : function(valueText, inst) {
				var nameval = $('.grade-current>li').eq(inst._tempWheelArray[0]).children('span').attr('data-val');
				$("#current-name-val").val(nameval);
			},
			formatResult : function(array) { //返回自定义格式结果
				n = $('.grade-current>li').eq(array[0]).children('span');
				return n.text();
			}
		});

		//上传信息

		var $list = $('#fileList'), $btn = $('#ctlBtn'), state = 'pending',
		// 优化retina, 在retina下这个值是2
		ratio = window.devicePixelRatio || 1,

		// 缩略图大小
		thumbnailWidth = 60 * ratio, thumbnailHeight = 60 * ratio,

		// Web Uploader实例
		uploader;

		// 初始化Web Uploader
		uploader = WebUploader.create({

			// 自动上传。
			auto : true,
			// 文件接收服务端。
			server : 'http://upload.7881.com/file/fileUploadFlash.action',
			// 选择文件的按钮。可选。
			// 内部根据当前运行是创建，可能是input元素，也可能是flash.
			pick : '#filePicker',
			// 只允许选择文件，可选。
			formData : {
				"userid" : userinfo.userid
			},
			accept : {
				title : 'Images',
				extensions : 'gif,jpg,jpeg,png',
				mimeTypes : 'image/gif,image/jpg,image/jpeg,image/png'
			},
			fileVal : 'fileImage',
			fileNumLimit : 4,
			duplicate : true
		});

		uploader.on('beforeFileQueued', function(file) {
			if (file.size > 2 * 1024 * 1024) {
				Alert("单个文件最大不能超过2M");
				return false;
			}
		});
		// 文件上传成功，给item添加成功class, 用样式标记上传成功。
		uploader.on('uploadSuccess', function(file, response) {
			
			if (imgUrlList.length >= 4) {
				Alert("最多上传4张照片");
				return false;
			}
			
			var $li = $('<div id="' + file.id + '" class="file-item thumbnail">' + '<img class="exptpic" />' + '<div class="up-del"><em class="iconfont">&#xe608;</em></div>' + '</div>'), $img = $li
					.find('img');
			$list.append($li);

			//因为这个元素有多个，所以先把添加事件的控件事件去掉
			$('.up-del').unbind("click"); 
			$(".up-del").on("click", function() {
				uploader.removeFile(file);
				imgUrlList.splice($(this).parent().index(), 1);
				$(this).parent().remove();
				return;
			});

			// 创建缩略图
			uploader.makeThumb(file, function(error, src) {
				if (error) {
					$img.replaceWith('<span>不能预览</span>');
					return;
				}

				$img.attr('src', src);
				$img.attr('data-src', src);
			}, thumbnailWidth, thumbnailHeight);
			imgUrlList.push(response.url);
		});

		// 文件上传失败，现实上传出错。
		uploader.on('uploadError', function(file) {
			var $li = $('#' + file.id), $error = $li.find('div.error');

			// 避免重复创建
			if (!$error.length) {
				$error = $('<div class="error"></div>').appendTo($li);
			}

			Alert('上传失败');
		});

		
		
		if(me.params.currentgrade){
			$(me.getElementByXid("text-span")).html("若角色名不变更可无需再次验证<br/>资料提交完成后，请登录您录入的角色账号并添加对应<br/>区服的官方账号为好友！");
		}
		
	};
	
	
	
	Model.prototype.exptpic = function(event) {
		var me = this;
		var src = $(me.getElementByXid("exptpic")).attr("data-src");
		$(".openbig").find("img").attr("src", src);
		var html = $(".openbig").html();
		layer.open({
			className : 'lookbig',
			content : html,
			success : function() {
				$(".lookbig").find(".closebtn").click(function() {
					layer.closeAll();
				});
			}
		});
	};
	
	
	Model.prototype.buttonblue = function(event) {
		console.log("imgUrlList:", imgUrlList);
		if (imgUrlList.length == 0) {
			var _html = $(".no-upload-tip").html();
			layer.open({
				content : _html,
				className : 'com-tips-02',
				success : function() {
					$(".com-tips-02 a.btn-close").click(function() {
						layer.closeAll();

					});
				}
			});

			return false;
		}
		var mustlength = $(".release-info-wrap").find(".must-input").length;
		$(".release-info-wrap").find(".must-input").each(function(index) {
			if ($(this).val() == "") {
				var alert_txt = $(this).attr("data-prompt");
				Alert(alert_txt);
				return false;
			};
			
			if (mustlength - 1 == index) {
				// 开发提交表单
				dlm.sendRequest({
					"action" : "/beater/addBeaterRecord.action",
					"params" : {
						applygrade :  $.trim($("#current-name-val").val()),
						areaname : $("#qu-val").val() + $("#fu-val").val(),
						rolename : $("#role-name-val").val(),
						pictures : imgUrlList.join(",")
					},
					"success" : function(json) {
						if (json.result == 1) {
							console.log(json);
							imgUrlList = [];
							
							justep.Shell.closeAll();
							justep.Shell.showPage("main");
							
							Alert("申请成功");
							me.close();

						} else {
							Alert(json.data);
						}

					}
				});
			}
		});
	};
	
	Model.prototype.back = function(event) {
		this.close();
	};

	return Model;
});