define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var browser = require("$UI/system/lib/base/browser");
	
	var Model = function(){
		this.callParent();
	};
	
	Model.prototype.totalCount = 0;
	Model.prototype.totalIntegral = 0;
	
	Model.prototype.doLoad = function(event)
	{
		var me = this;        
        if (browser.isX5App) {
			if (browser.isIOS) {
	        	me.comp("panel1").setHeight("top", 63);
	        } 
		}
	};
	
	Model.prototype.subtract = function(event)
	{
		var me = this;
		event.stopPropagation();
		var row = event.bindingContext.$object;
		var count = parseInt(row.val("count") || 0);
		if (count > 0) {
			row.val("count", --count);
			me.total();
		}
	};	
	
	Model.prototype.add = function(event)
	{
		var me = this;
		event.stopPropagation();
		var row = event.bindingContext.$object;
		var count = parseInt(row.val("count") || 0);
		if (count < row.val("maxCount")) {
			row.val("count", ++count);
			me.total();
		}
	};
	
	Model.prototype.total = function()
	{
		var me = this;
		var templateData = me.comp("data1");
		var totalCount = 0;
		var totalIntegral = 0;
		templateData.each(function(obj){
			var count = parseInt(obj.row.val("count") || 0);
			if (count > 0) {
				totalCount++;
				totalIntegral += count * Math.ceil(obj.row.val('amount') * 50);
			}
		});
		me.totalCount = totalCount;
		me.totalIntegral = totalIntegral;
		$(me.getElementByXid("totalCount")).html(totalCount + "个");
		$(me.getElementByXid("totalIntegral")).html(totalIntegral);
	};
	
	Model.prototype.exchange = function()
	{
		var me = this;
		var templates = [];
		var templateData = me.comp("data1");
		templateData.each(function(obj){
			var count = parseInt(obj.row.val("count") || 0);
			if (count > 0) {
				templates.push({id: obj.row.val("id"), name: obj.row.val('name'), count: (count + '')});
			}
		});
		if (templates.length == 0) {
			Alert("请至少选择一种优惠券兑换");
			return;
		}
		if (me.totalIntegral > me.params.score) {
			Alert("您的积分不够，无法兑换当前选择的券");
			return;
		}
		
		var data = {templates: JSON.stringify(templates)};
		dlm.sendRequest({
			"action":"/coupon/exchangeByIntegral.action",
			"params": data,
			"success":function(json){
				if (json.result == 1) {
					Alert("兑换成功");
					if (me.params.refresh) {
						me.params.refresh();
					}
					setTimeout(function(){me.close();}, 500);
				}
				else {
					Alert(json.data);
				}
			}
		});	
	};
	
	Model.prototype.back = function(event)
	{
		this.close();
	};
	
	Model.prototype.data1CustomRefresh = function()
	{
		var me = this;
		dlm.sendRequest({
			"action":"/coupon/getIntegralCouponTemplates.action",
			"params":{},
			"success":function(json){
				if (json.result == 1) {
					me.comp("data1").clear();
					if (json.data != null) {
						for (var i = 0; i < json.data.length; i++) {
							var data = json.data[i];
							var buffer = [];
							var grate_day_limit = data.grate_day_limit;
							if (grate_day_limit != null) {
								grate_day_limit = parseInt(grate_day_limit);
								if (grate_day_limit > 0) {
									buffer.push(grate_day_limit);
								}
							}
							var grate_user_limit = data.grate_user_limit;
							if (grate_user_limit != null) {
								grate_user_limit = parseInt(grate_user_limit);
								if (grate_user_limit > 0) {
									buffer.push(grate_user_limit);
								}
							}
							var grate_day_user_limit = data.grate_day_user_limit;
							if (grate_day_user_limit != null) {
								grate_day_user_limit = parseInt(grate_day_user_limit);
								if (grate_day_user_limit > 0)  {
									buffer.push(grate_day_user_limit);
								}
							}
							data.maxCount = buffer.length > 0 ? Math.min.apply(null, buffer) : 1000;
						}
					}
					me.comp("data1").loadData(json.data);
				}
				else {
					Alert(json.data);
				}
			}
		});
	};

	return Model;
});