define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var browser = require("$UI/system/lib/base/browser");
	var Model = function(){
		this.callParent();
	};
	
	var iscrollObj;//列表拖动对象
	
	Model.prototype.doLoad = function()
	{
		var me = this; 
		if (browser.isX5App) {
			if (browser.isIOS) {
	        	me.comp("panel1").setHeight("top", 63);
	        } 
		}
		var pulldownAction = function() {
			//刷新数据
			$(me.getElementByXid("loading")).show();
			me.comp("data1").refreshData({"confirm":false});
			if(iscrollObj){
				iscrollObj.refresh();
				iscrollObj.scrollTo(0, 0, 100, IScroll.utils.ease.circular);
			}
		};
		iscrollObj = iscrollAssist.newVerScrollForPull($(me.getElementByXid("wrapper")),pulldownAction,pulldownAction);
		iscrollObj.refresh();
	};
	
	Model.prototype.data1CustomRefresh = function(event)
	{
		var me = this;
		me.getList();
	};
	
	Model.prototype.getList = function(event)
	{
		var me = this;
		var ignoreOrders = localStorage.getItem("ignoreOrders");
		dlm.sendRequest({
			"action":"/order/getPushData.action",
			"params":{
				ignoreOrders: ignoreOrders
			},
			"async":true,
			"success":function(json){
				console.log(json);
				if (json && json.result == "1" && json.data && ("ignoreOrders" in json.data)) {
					localStorage.setItem("ignoreOrders", json.data.ignoreOrders.join(","));
				}
				me.comp("data1").clear();
				if(json && json.result == "1" && json.data && json.data.data){
					var orders = JSON.stringify(json.data.data || []);
					localStorage.setItem("pushOrders", orders);
					localStorage.setItem("pushOrdersRead", false);//不让外面刷新
					me.comp("data1").loadData(json.data.data);
					if (me.isEdit == true) {
						$(me.getElementByXid("wrapper")).find('.hall-list-item').addClass('checked').removeClass('no-checked');
					}
				}
				$(me.getElementByXid("loading")).hide();
				//如果列表没有数据，隐藏下拉刷新，显示无更多数据
				if(me.comp("data1").count() == 0){
					$(me.getElementByXid("pulldown")).hide();
					$(me.getElementByXid("listEnd")).html(json.data.recommend ? "没有更多数据了": "未开启推荐");
					$(me.getElementByXid("listEnd")).show();
				}else{
					$(me.getElementByXid("pulldown")).show();
				}
				//隐藏加载中效果
				$(me.getElementByXid("pullup")).hide();
				setTimeout(function(){
					if(iscrollObj){
						iscrollObj.refresh();
						iscrollObj.scrollTo(0, 0, 100, IScroll.utils.ease.circular);
					}
				},300);
			}
		});
	};
	
	Model.prototype.editClick = function(event)
	{
		var me = this;
		$(me.getElementByXid("wrapper")).find('.hall-list-item').addClass('checked').removeClass('no-checked');
		me.isEdit = true;
		$(me.getElementByXid("btn-edit")).css('display','none');
		$(me.getElementByXid("btn-setting")).css('display','none');
		$(me.getElementByXid("btn-submit")).css('display','block');
		
		$(me.getElementByXid("recommended-operate")).css('display','block');
		
	};
	
	Model.prototype.receiveOrder = function(event)
	{
		var me = this;
		var target = event.currentTarget;
		if($(me.getElementByXid("btn-edit")).css('display')=='block'){
			//跳转到订单详情页面
			var row = event.bindingContext.$object;
			var orderid = row.val("orderid");
			var currParams;
			//校验登录状态
			var userinfo = localStorage.userinfo ? JSON.parse(localStorage.userinfo) : null;
			if(userinfo){
				currParams = {"orderid":orderid};
			}else{
				//用户为登录，进入详情页面，只显示订单的基本信息
				currParams = {"orderid":orderid,"type":"status"};
			}
			
			//获得订单的信息
			dlm.sendRequest({
				"action":"/orderinfo.action",
				"params":currParams,
				"success":function(json2){
					if(json2 && json2.result == "1" && json2.data && json2.data.info.orderstatus == "1"){
						dlm.goPage("receiveOrder",{"orderinfo":json2.data});
					}else if(json2 && (json2.result == "3" || json2.result == "4")){
						Alert("请先登录");
						dlm.goPage("login",{});
					}else{
						//不能接单提示
						Alert("该订单已被接或下架，尝试其他订单或下拉刷新新订单吧~");
					}
				}
			});
		
		}
		else{
			$(target).toggleClass("on");
		}
	};
	
	Model.prototype.finishClick = function()
	{
		var me = this;
		$(me.getElementByXid("wrapper")).find('.hall-list-item').addClass('no-checked').removeClass('checked');
		me.isEdit = false;
		$(me.getElementByXid("btn-edit")).css('display','block');
		$(me.getElementByXid("btn-setting")).css('display','block');
		$(me.getElementByXid("btn-submit")).css('display','none');
		
		
		$(me.getElementByXid("recommended-operate")).css('display','none');
	};
	
	Model.prototype.reverseSelect = function()
	{
		var me = this;
		$(me.getElementByXid("wrapper")).find('.hall-list-item').toggleClass("on");
	};
	
	Model.prototype.selectAll = function()
	{
		var me = this;
		$(me.getElementByXid("wrapper")).find('.hall-list-item').addClass('on');
	};
	
	Model.prototype.backClick = function(event)
	{
		this.close();
		localStorage.setItem("pushOrdersRead", true);//让外面重新刷新
	};
	
	Model.prototype.settingClick = function(event)
	{
		var me = this;
		dlm.goPage("pushOrderSetting", {back: function(){
			me.comp("data1").refreshData({"confirm":false});
		}});
	};
	
	Model.prototype.ignoreOrder = function(event)
	{
		var me = this;
		var items = $(me.getElementByXid("wrapper")).find('.hall-list-item.on');
		if (items.length == 0) {
			Alert("至少选择一笔推荐订单进行忽略");
			return;
		}
		//本地缓存
		var orderIds = [];
		var ignoreOrders = localStorage.getItem("ignoreOrders");
		if (ignoreOrders == null || /^\s*$/.test(ignoreOrders)) {
			//空白
		}
		else {
			orderIds = ignoreOrders.split(",");
		}
		items.find(".orderId").each(function(){
			orderIds.push($(this).val());
		});
		items.remove();
		localStorage.setItem("ignoreOrders", orderIds.join(","));
	};

	return Model;
});