define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dlm = require("$UI/dlapp/js/dlm");
	var browser = require("$UI/system/lib/base/browser");
	var Model = function(){
		this.callParent();
	};
	
	Model.prototype.backClick = function(event)
	{
		this.close();
		if (this.params.back) {
			this.params.back();
		}
	};
	
	Model.prototype.doLoad = function(event)
	{
		var me = this; 
		if (browser.isX5App) {
			if (browser.isIOS) {
	        	me.comp("panel1").setHeight("top", 63);
	        } 
		}
		
			
		Zepto('.bad-say').mobiscroll().treelist({
	        theme: 'mobiscroll',
	        lang: 'zh',
	        display: 'bottom',
	        inputClass: 'sec-input',
	        placeholder: '请选择每次推送条数',
	        onSelect: function (valueText, inst) {
	        	var badSayval = $('.bad-say>li').eq(inst._tempWheelArray[0]).children('span').attr('data-val');
	        	$("#badSay-val").val(badSayval);
	        },
	        formatResult: function (array) { //返回自定义格式结果
	        	badSay = $('.bad-say>li').eq(array[0]).children('span');
	        	return  badSay.text();                   
	        }
	    });
		
		var grades = [
		              '青铜3', '青铜2', '青铜1', 
		              '白银3', '白银2', '白银1',
		              '黄金4', '黄金3', '黄金2', '黄金1', 
		              '铂金4', '铂金3', '铂金2', '铂金1', 
		              '钻石5', '钻石4', '钻石3', '钻石2', '钻石1', 
		              '星耀5', '星耀4', '星耀3', '星耀2', '星耀1', 
		              '最强王者'
		];
		
		me.gradesMap = {};
		var buffer = [];
		buffer.push(  "<li>"
					+ 	"<span data-val=''>不限</span>"	
					+ "</li>");
		for (var i = 0; i < grades.length; i++) {
			me.gradesMap[grade] = i;
			var grade = grades[i];
			var perGradeHtml = "<li>"
							+ 		"<span data-val='" + grade + "'>" + grade + "</span>"	
						    + "</li>";
			buffer.push(perGradeHtml);
		}
		var gradeHtml = buffer.join("");
		$(me.getElementByXid("grade-start")).html(gradeHtml);
		$(me.getElementByXid("grade-target")).html(gradeHtml);
		Zepto('.grade-start').mobiscroll().treelist({
	        theme: 'mobiscroll',
	        lang: 'zh',
	        display: 'bottom',
	        inputClass: 'sec-input',
	        placeholder: '请选择初始段位',
	        onSelect: function (valueText, inst) {
	        	var nameval = $('.grade-start>li').eq(inst._tempWheelArray[0]).children('span').attr('data-val');
	        	$("#start-name-val").val(nameval);
	        },
	        formatResult: function (array) { //返回自定义格式结果
	        	n = $('.grade-start>li').eq(array[0]).children('span');
	        	return  n.text();                   
	        }
	    });
    
	    Zepto('.grade-target').mobiscroll().treelist({
	        theme: 'mobiscroll',
	        lang: 'zh',
	        display: 'bottom',
	        inputClass: 'sec-input',
	        placeholder: '请选择末位段位',
	       onSelect: function (valueText, inst) {
	        	var nameval = $('.grade-target>li').eq(inst._tempWheelArray[0]).children('span').attr('data-val');
	        	$("#target-name-val").val(nameval);
	        },
	        formatResult: function (array) { //返回自定义格式结果
	        	n = $('.grade-target>li').eq(array[0]).children('span');
	        	return  n.text();                   
	        }
	    });
	    me.doLoadData();
	};
	
	Model.prototype.doLoadData = function()
	{
		var me = this;
		//请求优质打手信息
		dlm.sendRequest({
			"action" : "/beater/getBeaterUserInfo.action",
			"params" : {},
			"success" : function(json) {
				if (json.result == 1) {
					var data = json.data;
					if (data.recommend == 1) {
						//推荐
						$(me.getElementByXid("span-switch")).addClass("on");
					}
					else {
						$(me.getElementByXid("span-switch")).removeClass("on");
					}
					//推荐条数
					$("#badSay-val").val(data.recommendnum);
					$("#badSay-val").next().val(data.recommendnum);
					//段位
					if (data.recommendbegin) {
						$("#start-name-val").val(data.recommendbegin);
						$("#start-name-val").next().val(data.recommendbegin);
					}
					else {
						$("#start-name-val").val("");
						$("#start-name-val").next().val("不限");
					}
					if (data.recommendend) {
						$("#target-name-val").val(data.recommendend);
						$("#target-name-val").next().val(data.recommendend);
					}
					else {
						$("#target-name-val").val("");
						$("#target-name-val").next().val("不限");
					}
				}
				else {
					Alert(json.data);
				}
			}
		});	
	};
	
	Model.prototype.switchClick = function(event)
	{
		var me = this;
		if ($(me.getElementByXid("span-switch")).hasClass("on")) {
			$(me.getElementByXid("span-switch")).removeClass("on");
		}
		else {
			$(me.getElementByXid("span-switch")).addClass("on");
		}
		
	};
	
	Model.prototype.doSave = function(event)
	{
		var me = this;
		var data = {};
		data.recommend = $(me.getElementByXid("span-switch")).hasClass("on") ? "1" : "2";
		data.recommendnum = $("#badSay-val").val();
		data.recommendbegin = $("#start-name-val").val();
		data.recommendend = $("#target-name-val").val();
		var start = me.gradesMap[data.recommendbegin];
		var end = me.gradesMap[data.recommendend];
		if (start >= 0 && end >= 0 && start >= end) {
			Alert("初始段位要小于末位段位");
			return;
		}
		dlm.sendRequest({
			"action" : "/order/savePushInfo.action",
			"params" : data,
			"success" : function(json) {
				Alert(json.data);
				setTimeout(function(){me.backClick();}, 500);
			}
		});
	};

	return Model;
});