define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	
	var Model = function(){
		this.callParent();
	};

	Model.prototype.a1Click = function(event){
		this.close();
	};

	//清空搜索记录
	Model.prototype.span1Click = function(event){
		localStorage.searchList = null;
		searchList = null;
		this.comp("data1").refreshData({"confirm":false});
	};
	
	//缓存中的历史记录
	var searchList = null;
	
	//历史记录数据加载和刷新
	Model.prototype.data1CustomRefresh = function(event){
		searchList = localStorage.searchList ? JSON.parse(localStorage.searchList) : null;
		this.comp("data1").clear();
		if(searchList){
			this.comp("data1").loadData(searchList.reverse());
			searchList = localStorage.searchList ? JSON.parse(localStorage.searchList) : null;
		}
	};

	Model.prototype.modelLoad = function(event){
		var me = this;
		//设置关键字
		if(me.params.keyword){
			$(me.getElementByXid("search")).val(me.params.keyword);
		}
		
	    //设置提示语
		if(me.params.placeholder){
			$(me.getElementByXid("search")).attr("placeholder",me.params.placeholder);
		}
	};
	
	//新增值到本地缓存
	Model.prototype.addKeyword = function(msg){
		if(!searchList){
    		searchList = [];
    	}else{
    		for(var i = 0 ; i < searchList.length ; i++){
    			var key = searchList[i].keyword;
    			if(key == msg){
    				searchList.splice(i,1);
    				break;
    			}
    		}
    		if(searchList.length >= 5){
    			searchList.shift();
    		}
    	}
    	searchList.push({"keyword":msg});
    	localStorage.searchList = JSON.stringify(searchList);
	}

	//点击了一个历史记录
	Model.prototype.li2Click = function(event){
		var row = event.bindingContext.$object;
		var msg = row.val("keyword");
		this.addKeyword(msg);
		this.params.search(msg);
		this.close();
	};

	Model.prototype.div1Keyup = function(event){
		var me = this;
		var obj = event.originalEvent;
		if (obj.keyCode == "13") {
        	var msg = $(me.getElementByXid("search")).val().replace(/(^\s*)|(\s*$)/g,'');
        	me.params.search(msg);
        	if(msg != ""){
	        	me.addKeyword(msg);
        	}
        	me.close();
        }
	};

	return Model;
});