define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var constant = require("$UI/dlapp/js/constant");
	
	var Model = function(){
		this.callParent();
	};
	
	Model.prototype.backClick = function(){
		this.close();
	};
	
	Model.prototype.tabClick = function(event){
		var dom_obj = event.delegateTarget;
		var index = $(dom_obj).index();
		
		$(this.getElementByXid("hero-list")).hide();
		$(this.getElementByXid("rune-list")).hide();
		$(this.getElementByXid("detail-info-wrap")).hide();
		
		if(index === 0){
			$(this.getElementByXid("hero-list")).show();
		}else if(index === 1){
			$(this.getElementByXid("detail-info-wrap")).show();
		}else if(index === 2){
			$(this.getElementByXid("rune-list")).show();
		}
		$(dom_obj).addClass("on").siblings("li").removeClass("on");
	};
	
	//查询TGP
	Model.prototype.ajaxTgp = function(url,data,fun){
		$.ajax({
			"type" : "get",
			"async" : true,
			"dataType" : "jsonp",
			"jsonp": "callback",
			"url" : url,
			"data":data,
			"success" : fun,
			"error" : function(){
				
			}
		});
	};

	Model.prototype.modelLoad = function(event){
		var me = this;
		me.ajaxTgp(
			constant.WEB_URL + "/"+this.params.orderid+"/tgp.html",
			{"appflag":"1"},
			function(json){
				if(json && json.unid && json.qf){
					var unid = json.unid;
					var areaid = json.qf;
					//查询英雄
					me.queryHero(unid, areaid);
		        	//查询战绩
					me.queryRecord(unid, areaid);
		        	//查询符文
				    me.queryRunes(unid,areaid);
				}else{
					//没找到角色
					$(me.getElementByXid("hero-list")).hide();
					$(me.getElementByXid("rune-list")).hide();
					$(me.getElementByXid("detail-info-wrap")).hide();
					$(me.getElementByXid("lp-tab-top")).hide();
					$(me.getElementByXid("bbloading")).hide();
					$(me.getElementByXid("no-contxt")).show();
				}
			}
		);
	};
	
	//查询英雄
	Model.prototype.queryHero = function(unid,areaid){
		var me = this;
		me.ajaxTgp(
			constant.WEB_URL + "/tgp/tcall.action",
			{
				"p":'[[3,{"qquin":"'+unid+'","area_id":"'+areaid+'","bt_num":"1","bt_list":["4"],"offset":0,"limit": 200}]]'
	        },
			function(json2){
	        	$(me.getElementByXid("bbloading")).hide();
	        	if(json2 && json2.data && json2.data[0].battle_list){
	        		var data = json2.data[0];
	        		//获得近期200场排位数据，排除相同的英雄
		        	var temp = data.battle_list;
		            data.battle_list = [];
		        	var json = {};
		        	for(var kk = 0;kk < temp.length; kk++){
		        		if(!json[temp[kk].champion_id]){
		        			data.battle_list.push(temp[kk]);
		        			json[temp[kk].champion_id] = 1;
		    			  }
		        	}
		        	//更新页面
		        	for(var i = 0; i < data.battle_list.length ; i++){
		        		var item = data.battle_list[i];
		        		var ename = window.PLS.LOLChampion[item.champion_id].ename;
		        		var cname = window.PLS.LOLChampion[item.champion_id].title;//用称号代替名称
		        		var html = '<li><a><div class="img-box"><img src="http://cdn.tgp.qq.com/pallas/images/champions/'+ename+'.png" alt="'+cname+'" style="width:2.5rem;height:2.5rem;"/></div>';
		        		html += '<p>'+cname+'</p></a></li>';
		        		$(me.getElementByXid("hero-list")).find(".clearfix").append(html);
		        	}
	        	}
			}
		);
	};
	
	//查询战绩
	Model.prototype.queryRecord = function(unid,areaid){
		var me = this;
		me.ajaxTgp(
			constant.WEB_URL + "/tgp/tcall.action",
			{
				"p":'[[14,{"battle_type":-1,"qquin":"'+unid+'","area_id":"'+areaid+'"}],[44,{"sid":5,"qquin":"'+unid+'","area_id":"'+areaid+'"}],[44,{"sid":4,"qquin":"'+unid+'","area_id":"'+areaid+'"}]]',
				 "cacheTime": 300
	        },
			function(json2){
	        	if(json2 && json2.data && json2.data.length == 3){
	        		var s7 = json2.data[0], s7_j = json2.data[1], s6 = json2.data[2];
	        		var title_list = ["经典对战","S7单双排","S7灵活组排","S7季前赛","S6排位赛"];
	        		var jd;
		            var dsp;
		            var lhzp;
		            for(var i = 0; i < s7.batt_sum_info.length; i++){
		            	var temp = s7.batt_sum_info[i];
		            	if(temp.battle_type == 1){
		            		jd = temp;
		            	}
		            	if(temp.battle_type == 4){
		            		dsp = temp;
		            	}
		            	if(temp.battle_type == 3){
		            		lhzp = temp;
		            	}
		            }
		            for(var i = 0; i < s7.batt_sum_info.length; i++){
		            	var temp = s7.batt_sum_info[i];
		            	if(temp.battle_type == 3 && temp.last_battle_time > 0){
		            		lhzp = temp;
		            	}
		            }
		            var data_list = [jd, dsp, lhzp, s7_j.team_sum_info, s6.batt_sum_info];
	        		$(me.getElementByXid("detail-info-wrap")).find(".record-info-item").each(function(i){
	        			var data = data_list[i];
	        			if(data){
		        			var dom = $(me.getElementByXid("detail-info-wrap")).find(".record-info-item").eq(i);
		        			var title = title_list[i];
		        			var use_num = data.total_num - data.leave_num;
		        			var lose_num = data.lose_num;
		        			var win_num = data.win_num;
		        			var win_rate = Math.ceil(win_num / Math.max(1, use_num) * 100);
		        			var html = '';
		        			html += '<div class="record-info-l"><h5>'+title+'</h5><p>'+use_num+'场</p></div>'+
									'<div class="record-info-r"><h5></h5><h4></h4>'+
									'<p>胜 <em>'+win_rate+'</em>%　'+win_num+'场</p></div>';
		        			dom.html(html);
		        			if(i === 1 || i == 2){
		        				var tierid = data.tier;
		        				var tier = window.PLS.LOLKeywords.tier[tierid];
		        				var level = window.PLS.LOLKeywords.level[data.queue];
		        				var tiername = tier+" "+level;
		        				var win_point = data.win_point;
		        				var dom2 = $(me.getElementByXid("detail-info-wrap")).find(".con-item").eq(i-1);
		        				if(tierid == 255){
		        					tierid = 7;
		        					tiername = "无段位";
		        					win_point = 0;
		        				}
		        				html = 	'<h5><em class="quarter">'+title+'</em></h5>'+
		        						'<div class="qu-img"><img src="http://cdn.tgp.qq.com/pallas/images/pallas/grade'+tierid+'.png" alt="" style="width:2.4rem;height:1.84rem;"/></div>'+
		        						'<p>'+tiername+'</p><p>'+win_point+'胜点</p>';
		        				dom2.html(html);
		        			}
	        			}
	        		});
	        		setTimeout(function(){
	        			$(me.getElementByXid("bbloading")).hide();
	        			//战绩动画显示
		        		$(me.getElementByXid("detail-info-wrap")).find(".record-info-r").each(function(index){
							var _wid = parseFloat($(this).parent().find("em").text());
							$(this).find("h4").css("width",_wid+"%");
							$(this).find("p").animate({
							    opacity: 1
							  }, 1000, function() {});
						});
	        		},500)
	        	}
			}
		);
	};
	
	//符文展示
	Model.prototype.showRunesStatus = function(data,fwArr) {
		var me = this;
	    var htmlCode = [],
	    tempStr;
	    if (data) {
	        for (var n in data) {
	            if (data[n] > 0) {
	                tempStr = parseInt(data[n]) == data[n] ? data[n] : data[n].toFixed(1);
	                if (n == "%冷却时间" || n == "%死亡时间") {
	                    tempStr = "<span>" + n.replace("%", "") + "<br/>-" + tempStr + "%</span>";
	                } else {
	                    if (n.indexOf("%") > -1) {
	                        tempStr = "<span>" + n.replace("%", "") + "<br/>+" + tempStr + "%</span>";
	                    } else {
	                        tempStr = "<span>" + n + "<br/>+" + tempStr + "</span>";
	                    }
	                }
	                htmlCode.push(tempStr);
	            }
	        }
	        if (htmlCode.length > 0) {
	        	$(me.getElementByXid("rune-list")).find(".rune-info-box").html(htmlCode.join(""));
	        }
	    }
	    if(fwArr){
	    	var html1 = '<h5>大精华</h5>';
	    	var html2 = '<h5>红色印记 / 黄色符印 / 蓝色雕纹</h5>';
	    	for(var n in fwArr){
	    		if(fwArr[n] >= 10){
	    			html1 += '<div class="rune-info-type">';
	    			html1 += '<span class="runes_d '+n+'"></span> X'+fwArr[n]/10+'</div>';
	    		}else{
	    			html2 += '<div class="rune-info-type">';
	    			html2 += '<span class="runes_x '+n+'"></span> X'+fwArr[n]+'</div>';
	    		}
	    	}
	    	$(me.getElementByXid("rune-list")).find(".rune-info-item").eq(0).html(html1);
	    	$(me.getElementByXid("rune-list")).find(".rune-info-item").eq(1).html(html2);
	    }
	};
	
	Model.prototype.mkHtmlTmp = function(obj, tmp) {
	    var htmlCode, re;
	    if (typeof obj === "object" && typeof tmp === "string") {
	        htmlCode = tmp;
	        for (var n in obj) {
	            if (typeof obj[n] === "string" || typeof obj[n] === "number") {
	                re = new RegExp("{#" + n + "#}", "gi");
	                htmlCode = htmlCode.replace(re, obj[n]);
	            }
	        }
	    }
	    return htmlCode || "";
	};
	
	//查询符文
	Model.prototype.queryRunes = function(unid,areaid){
		var me = this;
		me.ajaxTgp(
			constant.WEB_URL + "/tgp/get_player_mastery_spell.action",
			{
				"dtag":"runes",
				"callback":"getRunesCallback",
				"get_type":"2",
				"qquin":unid,
				"area_id":areaid,
				"t":new Date().getTime()
	        },
			function(json2){
	        	var data = [];
				for(var i = 0;i < json2["data"]["spell"].length; i++){
					data.push(json2["data"]["spell"][i]["slots"]);
					var html = '<li class="com-border0"><div class="jz-box"><p class="p1">'+json2["data"]["spell"][i].name+'</p></div></li>';
					$(me.getElementByXid("rune-list")).find(".ord-list-nav").find("ul").append(html);
				}
				$(me.getElementByXid("rune-list")).find(".ord-list-nav > ul > li").click(function(){
					$(this).addClass("on").siblings("li").removeClass("on");
					$(me.getElementByXid("rune-list")).find(".rune-list > .com-border0").html(json2["data"]["spell"][$(this).index()].name);
					me.showRunes($(this).index(), data);
				});
				$(me.getElementByXid("rune-list")).find(".ord-list-nav > ul > li").first().click();
			}
		);
	};
	
	Model.prototype.showRunes = function(index,data){
		var me = this;
		var st = {
		    curType: "runes",
		    typeList: ["runes", "talent"],
		    runesTag: 1,
		    talentTag: 1,
		    runesData: null,
		    talentData: null,
		    errFloat: null,
		    floatHandle: null
		};
    	var tempData,
	    runesData = PLS.LOLRunes,
	    tempArr, runesItem, tGold = 0,
	    re,fwArr = {};
	    var status = {
	        "生命值": 0,
	        "%生命值": 0,
	        "生命回复/5秒": 0,
	        "护甲 ": 0,
	        "法力回复/5秒": 0,
	        "法力值": 0,
	        "魔法抗性": 0,
	        "攻击力": 0,
	        "%攻击速度": 0,
	        "%暴击几率": 0,
	        "%暴击伤害": 0,
	        "%冷却时间": 0,
	        "%闪避几率": 0,
	        "法术穿透": 0,
	        "法术强度": 0,
	        "护甲穿透": 0,
	        "能量回复/5秒": 0,
	        "生命值(18级)": 0,
	        "生命回复/5秒(18级)": 0,
	        "护甲(18级)": 0,
	        "法力回复/5秒(18级)": 0,
	        "法力值(18级)": 0,
	        "魔法抗性(18级)": 0,
	        "攻击力(18级)": 0,
	        "%攻击速度(18级)": 0,
	        "%暴击几率(18级)": 0,
	        "%暴击伤害(18级)": 0,
	        "%冷却时间(18级)": 0,
	        "%闪避几率(18级)": 0,
	        "法术穿透(18级)": 0,
	        "法术强度(18级)": 0,
	        "护甲穿透(18级)": 0,
	        "能量回复/5秒(18级)": 0,
	        "%经验获得": 0,
	        "%死亡时间": 0,
	        "%移动速度": 0,
	        "%法术吸血": 0,
	        "%生命偷取": 0,
	        "每10秒获得金钱": 0
	    };
	    var runesTpl = "<div class='{#runesClass#}' slots='{#slots#}'><span class='signet-light-bg'></span><a class='signet-img{#imgUrl#}' href='javascript:void(0)' hidefocus img='{#id#}'></a><div class='runes-tips'><h3 class='level{#type#}'>级别{#type#}</h3><p class='grade2'>{#name#}</p><p>{#desc#}</p><p class='money'>{#gold#}</p></div></div>";
	    var curType = st["curType"],
	    curTag = st[curType + "Tag"],
	    tempStr,
	    htmlCode = [];
	    if (!data) {
	        tempData = [];
	        runesItem = st[curType + "Data"];
	        for (var i = 0; i < runesItem.length; i++) {
	            tempData.push(runesItem[i]["slots"])
	        }
	    } else {
	        tempData = data
	    }
	    tempData = tempData[index];
	    if (tempData) {
	        for (var n in tempData) {
	            runesItem = runesData[tempData[n]];
	            if (runesItem) {
	                runesItem["slots"] = n;
	                if (parseInt(n, 10) < 10) {
	                    runesItem["runesClass"] = "signet signet" + n
	                } else if (parseInt(n, 10) < 19) {
	                    runesItem["runesClass"] = "sigil sigil" + n
	                } else if (parseInt(n, 10) < 28) {
	                    runesItem["runesClass"] = "sculpture sculpture" + n
	                } else {
	                    runesItem["runesClass"] = "essence essence" + n
	                }
	                if (runesItem["img"] != "") {
	                    runesItem["imgUrl"] = " runes-" + runesItem["img"].replace(".png", "")
	                } else {
	                    runesItem["imgUrl"] = ""
	                }
	                tGold += runesItem["gold"] * 1;
	                if (runesItem["desc"].indexOf("金钱") > -1) {
	                    re = /([0-9\\.]{1,5})点金钱/gi;
	                    tempArr = re.exec(runesItem["desc"]);
	                    status["每10秒获得金钱"] = status["每10秒获得金钱"] + parseFloat(tempArr[1], 10)
	                } else if (runesItem["desc"].indexOf("%生命值") > -1) {
	                    re = /([0-9\\.]{1,5})%生命值/gi;
	                    tempArr = re.exec(runesItem["desc"]);
	                    status["%生命值"] = status["%生命值"] + parseFloat(tempArr[1], 10)
	                } else {
	                    for (var m in status) {
	                        if (runesItem["desc"].indexOf("18级") > -1) {
	                            if (m.indexOf("18级") > -1) {
	                                tempStr = m.split("(")[0];
	                                re = new RegExp("(" + tempStr.replace("/", "\\/") + ").+18级(\\+|\\-)([0-9\\.]{1,5})%?", "gi");
	                                tempArr = re.exec(runesItem["desc"]);
	                                if (tempArr) {
	                                    status[m] = status[m] + parseFloat(tempArr[3], 10)
	                                }
	                            }
	                        } else {
	                            if (runesItem["desc"].indexOf(m) > -1) {
	                                re = new RegExp("(\\+|\\-)([0-9\\.]{1,5})( |点)?" + m, "gi");
	                                tempArr = re.exec(runesItem["desc"]);
	                                if (tempArr) {
	                                    status[m] = status[m] + parseFloat(tempArr[2], 10)
	                                }
	                            }
	                        }
	                    }
	                }
	                tempStr = me.mkHtmlTmp(runesItem, runesTpl);
	                if (parseInt(n, 10) > 27) {
	                    tempStr = tempStr.replace("<span class='signet-light-bg'></span>", "")
	                }
	                htmlCode.push(tempStr);
	                var imgUrl = runesItem.imgUrl.replace(" ", "");
	                var dw = parseInt(n, 10) > 27 ? 10 : 1;
	                if(fwArr[imgUrl]){
	                	fwArr[imgUrl] = fwArr[imgUrl]+dw;
	                }else{
	                	fwArr[imgUrl] = dw;
	                }
	            }
	        }
	        if (htmlCode.length > 0) {
	            me.showRunesStatus(status,fwArr);
	        }
	    }
	}

	return Model;
});