define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var constant = require("$UI/dlapp/js/constant");
	
	var Model = function(){
		this.callParent();
	};
	
	Model.prototype.backClick = function(){
		this.close();
	};
	
	Model.prototype.tabClick = function(event){
		var dom_obj = event.delegateTarget;
		var index = $(dom_obj).index();
		
		$(this.getElementByXid("hero-list")).hide();
		$(this.getElementByXid("rune-list")).hide();
		$(this.getElementByXid("detail-info-wrap")).hide();
		
		if(index === 0){
			$(this.getElementByXid("hero-list")).show();
		}else if(index === 1){
			$(this.getElementByXid("detail-info-wrap")).show();
		}else if(index === 2){
			$(this.getElementByXid("rune-list")).show();
		}
		$(dom_obj).addClass("on").siblings("li").removeClass("on");
	};
	
	//查询TGP
	Model.prototype.ajaxTgp = function(url,data,fun){
		$.ajax({
			"type" : "get",
			"async" : true,
			"dataType" : "jsonp",
			"jsonp": "callback",
			"url" : url,
			"data":data,
			"success" : fun,
			"error" : function(){
				
			}
		});
	};
	
	//没找到角色
	Model.prototype.noSearch = function(){
		var me = this;
		$(me.getElementByXid("hero-list")).hide();
		$(me.getElementByXid("rune-list")).hide();
		$(me.getElementByXid("detail-info-wrap")).hide();
		$(me.getElementByXid("lp-tab-top")).hide();
		$(me.getElementByXid("bbloading")).hide();
		$(me.getElementByXid("no-contxt")).show();
	};

	Model.prototype.modelLoad = function(event){
		var me = this;
		me.ajaxTgp(
			constant.WEB_URL + "/"+this.params.orderid+"/tgp.html",
			{"appflag":"1"},
			function(jsonall){
				if(jsonall && jsonall.rolename && jsonall.servername){
					var world_id = 0;
					var area_id = 0;
					var open_id = "";
					var grade_level = 0;
					var grade_name = "--";
					var roleinfo = null;
					var rolename = decodeURI(jsonall.rolename.replace(/%e5%91%9c%e5%96%b5/g,"%").replace(/%e5%96%b5%e5%91%9c/g,"A"));
					var servername = decodeURI(jsonall.servername.replace(/%e5%91%9c%e5%96%b5/g,"%").replace(/%e5%96%b5%e5%91%9c/g,"A"));
					//服务器名称处理，去除前面的多少区
					if(servername.indexOf("区") > -1){
						var reg = new RegExp("([0-9]{1,3})区(.{1,5})");
						var r = servername.match(reg);
						if(r){
							servername = r[2];
						}
					}
					//搜索角色信息
					me.ajaxTgp(constant.WEB_URL + "/tgp/tcall_wzry.action",{
						"p":'{"key":"'+rolename+'","key_type":2}',
						"method":"/sgame/search_player"
					},function(json){
						if(json && json.data && json.data.length > 0 && json.data[0] && json.data[0].role_list[0]){
							//当只查到一个，且服为默认服时，直接使用
							if(json.data.length == 1 && servername == "默认服"){
								roleinfo = json.data[0].role_list[0];
							}else{
								//有多个时，识别区服
								for(var i = 0 ; i < json.data.length; i++){
									roleinfo = json.data[i].role_list[0];
									//区服相同，则查询成功
									if(KOG_World_Map[roleinfo.world_id] && KOG_World_Map[roleinfo.world_id].world_name == servername){
										break;
									}
									roleinfo = null;
								}
							}
							if(roleinfo){
								world_id = roleinfo.world_id;
								area_id = roleinfo.area_id;
								open_id = roleinfo.open_id;
								grade_level = roleinfo.grade_level ? roleinfo.grade_level : '';
								grade_name = grade_level && gradearr[grade_level] ? gradearr[grade_level] : '无段位';
				
								//获取账号基本信息
								me.getPlayerInfo(area_id,world_id,open_id,grade_level,grade_name);
								//查询英雄
								me.getHeroInfo(area_id,world_id,open_id);
							}else{
								//没找到角色
								me.noSearch();
							}
						}else{
							//没找到角色
							me.noSearch();
						}
					});
				}else{
					//没找到角色
					me.noSearch();
				}
			}
		);
	};
	
	//获取账号基本信息
	Model.prototype.getPlayerInfo = function(area_id,world_id,open_id,grade_level,grade_name){
		var me = this;
		var ranking_star = '--';
		this.ajaxTgp(constant.WEB_URL + "/tgp/tcall_wzry.action",{
			"p":'{"full_id":{"area_id":'+area_id+',"world_id":'+world_id+',"open_id":"'+open_id+'"}}',
			"method":"/sgame/player_info"
			},function(json){
				if(json && json.data && json.data.basic_info){
					ranking_star = json.data.basic_info.ranking_star != null ? json.data.basic_info.ranking_star : '--';
				}
				
				//查询战绩
				me.getBattleSum(area_id,world_id,open_id,grade_level,grade_name,ranking_star);
			});
	}

	//战绩数字
	Model.prototype.getBattleSum = function(area_id,world_id,open_id,grade_level,grade_name,ranking_star){
		var me = this;
		this.ajaxTgp(constant.WEB_URL + "/tgp/tcall_wzry.action",{
			"p":'{"full_id":{"area_id":'+area_id+',"world_id":'+world_id+',"open_id":"'+open_id+'"},"offset":0,"model":0}',
			"method":"/sgame/player_battle_sum"
		},function(json){
			if(json && json.data && json.data.length > 0){
				for(var i = 0; i < json.data.length ;i++){
					//用到的参数
					var obj = json.data[i].data;
					var wins = obj.wins;
					var losses = obj.losses;
					var sum = losses+wins;
					var win_rate = Math.ceil(wins / Math.max(1, sum) * 100);
					var area_type = area_type_arr[i];
					var grade_name_temp = i == 2 ? grade_name : "--";
					
					//手机版拼接
					var dom = $(me.getElementByXid("detail-info-wrap")).find(".record-info-item").eq(i);
					var _html = '<div class="record-info-l"><h5>'+area_type+'</h5><p>'+sum+'场</p></div>'+
									'<div class="record-info-r"><h5></h5><h4></h4>'+
									'<p>胜 <em>'+win_rate+'</em>%　'+wins+'场</p></div>';
        			dom.html(_html);
				}
				var dom2 = $(me.getElementByXid("detail-info-wrap")).find(".con-item").eq(0);
				var tierid = 0;
				if(grade_name.indexOf("王者") > -1){
					tierid = 0;
				}else if(grade_name.indexOf("大师") > -1){
					tierid = 6;
				}else if(grade_name.indexOf("钻石") > -1){
					tierid = 1;
				}else if(grade_name.indexOf("铂金") > -1){
					tierid = 2;
				}else if(grade_name.indexOf("黄金") > -1){
					tierid = 3;
				}else if(grade_name.indexOf("白银") > -1){
					tierid = 4;
				}else if(grade_name.indexOf("青铜") > -1){
					tierid = 5;
				}else{
					tierid = 7;
				}
				var _html = 	'<h5><em class="quarter">排位赛</em></h5>'+
						'<div class="qu-img"><img src="http://cdn.tgp.qq.com/pallas/images/pallas/grade'+tierid+'.png" alt="" style="width:2.4rem;height:1.84rem;"/></div>'+
						'<p>'+grade_name+'</p><p>'+ranking_star+'星</p>';
				dom2.html(_html);
				setTimeout(function(){
        			$(me.getElementByXid("bbloading")).hide();
        			//战绩动画显示
	        		$(me.getElementByXid("detail-info-wrap")).find(".record-info-r").each(function(index){
						var _wid = parseFloat($(this).parent().find("em").text());
						$(this).find("h4").css("width",_wid+"%");
						$(this).find("p").animate({
						    opacity: 1
						  }, 1000, function() {});
					});
        		},500);
			}
		});
	}
	
	//英雄信息
	Model.prototype.getHeroInfo = function(area_id,world_id,open_id){
		var me = this;
		this.ajaxTgp(constant.WEB_URL + "/tgp/tcall_wzry.action",{
			"p":'{"full_id":{"area_id":'+area_id+',"world_id":'+world_id+',"open_id":"'+open_id+'"},"offset":0,"limit":100,"day_num":100}',
			"method":"/sgame/prefer_hero_info"
		},function(json){
			if(json && json.data && json.data.hero_list){
				for(var i = 0 ; i < json.data.hero_list.length; i++){
					//参数
					var obj = json.data.hero_list[i];
					var hero_id = obj.hero_id;
					var hero_name = KOG_Hero_Info[hero_id].hero_name;
					var hero_img = "http://cdn.tgp.qq.com/kog/v3/images/hero/"+KOG_Hero_Info[hero_id].hero_img_id+".png";
					
					//手机版拼接html
					var html = '<li><a><div class="img-box"><img src="'+hero_img+'" alt="'+hero_name+'" style="width:2.5rem;height:2.5rem;"/></div>';
	        		html += '<p>'+hero_name+'</p></a></li>';
	        		$(me.getElementByXid("hero-list")).find(".clearfix").append(html);
				}
			}
		});
	}
	
	return Model;
});